# DO NOT MESS WITH THE FOLLOWING UNLESS YOU KNOW WHAT YOU ARE DOING
# (The following makes heavy use of nested variables...)

dspname := $(shortname)-$(version)
$(dspname)_shortname := $(shortname)
$(dspname)_name := $(name)
$(dspname)_version := $(version)
$(dspname)_name_ver := $(dspname)

$(dspname)_lib_files := $(lib_files)
$(dspname)_raw_lib_files := $(raw_lib_files)
$(dspname)_themes := $(themes)
$(dspname)_source_files := $(source_files)
$(dspname)_directory := $(shortname)/$(version)

sources += $(addprefix $($(dspname)_directory)/,$($(dspname)_lib_files))

ifdef BUILDING

$(dsp_source_files) : $(dsp_source_dir)/% : $($(dspname)_directory)/%
	$(call cmdcheck,$(INSTALL) -m 755 $< $@, $(print-header))
$(dsp_lib_files) : $(dsp_lib_dir)/% : $($(dspname)_directory)/%
	$(call cmdcheck,$(INSTALL) -m 755 $< $@, $(print-header))
# Order of dependencies is important here...
$(dsp_lib_dir)/dAPI.py : $($(dspname)_directory)/dAPI.py
	$(ECHO) "DIRECTORY $(notdir $(patsubst %/lib/dAPI.py,%,$@))"
	$(call cmdcheck,$(CAT) $^ | $(M4) -P -DDSP_SHORTNAME=$($(notdir $(patsubst %/lib/dAPI.py,%,$@))_shortname) -DDSP_VERSION=$($(notdir $(patsubst %/lib/dAPI.py,%,$@))_version) > $@,$(print-header))
$(dsp_theme_files) : $(dsp_theme_dir)/% : $($(dspname)_directory)/%
	$(call cmdcheck,$(XMLLINT) --format -o $@ $< && $(CHMOD) 644 $@, $(print-header))

targets += $(dsp_dependencies)

dsp_rpms += $(dsp_rpm)
$(dsp_rpm) : $(dsp_dependencies)

delta_dsps.d : $(dsp_xml)

.PHONY: $(dsp_install)
dsp_installs += $(dsp_install)
$(dsp_install) : $(dsp_dependencies)

endif

