<?xml version="1.0"?>
<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

  <xsl:output method="text"/>

  <xsl:variable name="newline">
<xsl:text>
</xsl:text>
  </xsl:variable>

  <xsl:template match="*">
    <!-- 
        Only take leaf elements with non-zero-length strings that
        aren't numbers.
    -->
    <xsl:if test="not(./*) and string(.) and string(number(.)) = 'NaN'">
      <xsl:text>("</xsl:text>
      <xsl:call-template name="search-and-replace">
        <xsl:with-param name="input">
          <xsl:call-template name="search-and-replace">
            <xsl:with-param name="input" select="."/>
            <xsl:with-param name="search-string">
              <xsl:value-of select="$newline"/>
            </xsl:with-param>
            <xsl:with-param name="replace-string">
              <xsl:text>\n</xsl:text>
            </xsl:with-param>
          </xsl:call-template>
        </xsl:with-param>
        <xsl:with-param name="search-string">
          <xsl:text>"</xsl:text>
        </xsl:with-param>
        <xsl:with-param name="replace-string">
          <xsl:text>\"</xsl:text>
        </xsl:with-param>
      </xsl:call-template>
      <xsl:text>")</xsl:text>
      <xsl:value-of select="$newline"/>
    </xsl:if>
    <xsl:apply-templates select="./*"/>
  </xsl:template>

  <!-- 
      It's easier to cull out the elements we don't want translated,
      then to try to select the ones that we do.
  -->
  <xsl:template match="shortname|version|url|dapiversion|dapirelease|option[@name='license']/MultiInput|option[@name='archive_name']/SingleInput|option[@name='archive_type']/SingleInput|option[@name='domain_to_path']/ExclusiveSelect|option[@name='url_path']/SingleInput|option[@name='dbname']/SingleInput|option[@name='instance_admin_email' or @name='instance_admin' or @name='instance_admin_name']/SingleInput|option[@name='instance_pass1']/SingleInput|option[@name='instance_pass2']/SingleInput|option/ExclusiveSelect/value/internalValue|option/MultiSelect/value/internalValue"/>

  <xsl:template name="search-and-replace">
    <xsl:param name="input" select="."/>
    <xsl:param name="search-string"/>
    <xsl:param name="replace-string"/>
    <xsl:choose>
      <xsl:when test="$search-string and contains($input, $search-string)">
        <xsl:value-of select="substring-before($input, $search-string)"/>
        <xsl:value-of select="$replace-string"/>
        <xsl:call-template name="search-and-replace">
          <xsl:with-param name="input" 
                          select="substring-after($input, $search-string)"/>
          <xsl:with-param name="search-string" select="$search-string"/>
          <xsl:with-param name="replace-string" select="$replace-string"/>
        </xsl:call-template>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="$input"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

</xsl:stylesheet>
