import deployables_lib as dl
import urlparse
import shutil
import os

dl.load_msgs_module("phpbb-2.0.5", symtab = globals())

dir_moves = [('phpBB2', '') ]

def install(site, site_conf, instance_conf, msgs):

    actions = ['check_disk_quota', 'check_mysql_enabled', 'check_pass', '', 
	       'resolve_location',
               'db_create', 'db_probe', 'archive_unpack']
    args_dict = {'archive_unpack':       { 'dir_moves': dir_moves }}
    dl.do_install_actions(site, site_conf, instance_conf, msgs,
                          globals(), actions, args_dict)
    if msgs.get_severity() != msgs.ERROR:
        if instance_conf['url_loc']:
            split = urlparse.urlsplit(instance_conf['url_loc'])
            server_name = split[1]
            script_path = split[2]
        else:
            server_name = script_path = ''
        actions = ['exec_php_script', 'handle_security_mode', 'remove_files',
                   'access_url']
        args_dict = {
            'handle_security_mode': { 'files': ['install/install.php'] },
            'exec_php_script' : {
                 'script' : 'install/install.php',
                 'args' : {'install_step' : '1',
			   'lang' : 'english',
			   'dbms' : 'mysql',
			   'upgrade' : '0',
                           'server_name' : server_name,
			   'server_port' : '80',
			   'script_path' : script_path,
                           'dbhost' : '127.0.0.1',
                           'dbname' : instance_conf['dbname'],
                           'dbuser' : site_conf['mysql']['dbaseadmin'],
                           'dbpasswd' : instance_conf['dbpass'],
                           'prefix' : '',
                           'admin_name' : instance_conf['instance_admin'],
                           'admin_pass1' : instance_conf['instance_pass1'],
                           'admin_pass2' : instance_conf['instance_pass1'],
                           'board_email':instance_conf['instance_admin_email']}
                 },
            'remove_files': { 'files': ['install/', 'contrib/'] },
            }
        dl.do_install_actions(site, site_conf, instance_conf, msgs,
                              globals(), actions, args_dict)

def reconfigure(context, site, site_conf, old_site_conf, instance_conf,
                old_instance_conf, msgs):

    old_domain = old_site_conf['siteinfo']['domain']
    new_domain = site_conf['siteinfo']['domain']
    def url_sub(key, url):
        return dl.url_net_sub(url, new_domain, old_domain)
        
    actions = ['handle_url_loc', 'resolve_location', '',
               'archive_unpack', 'handle_username_change',
               'handle_db_changes', 'handle_security_mode']
    args_dict = {
        'archive_unpack':       { 'dir_moves': dir_moves },
        'handle_security_mode': { 'files': ['install/install.php'] },
        }
    dl.do_reconfigure_actions(context, site, site_conf, old_site_conf,
                              instance_conf, old_instance_conf, msgs,
                              globals(), actions, args_dict)
        
def remove(site, site_conf, instance_conf, msgs):
    dl.db_drop(site, site_conf, instance_conf)
    dl.install_loc_cleanup(site, site_conf, instance_conf, dir_moves)
    
def get_instance_configuration(context, site, site_conf, instance_conf,
                               old_instance_conf, locale, msgs):
    instance = dl.dsp_create_instance(instance_conf['shortname'],
                                      instance_conf['version'])
    dl.dsp_fill_instance(context, instance, site, site_conf,
                         instance_conf, old_instance_conf,
                         ['dbname', 'username', 'url_net', 'url_path',
                          'domain_to_path', 'instance_admin_email'])
    return instance
