<?
require_once "accesscheck.php";

include $coderoot . "structure.php";
ob_end_flush();

print "<h3>Creating tables</h3><br />\n";
$success = 1;
while (list($table, $val) = each($DBstruct)) {
  if (isset($force)) {
  	if ($table == "attribute") {
      $req = Sql_Query("select tablename from {$tables["attribute"]}");
      while ($row = Sql_Fetch_Row($req))
        Sql_Query("drop table if exists $table_prefix"."listattr_$row[0]");
   	}
    Sql_query("drop table if exists $tables[$table]");
	}
  $query = "CREATE TABLE $tables[$table] (\n";
  while (list($column, $val) = each($DBstruct[$table])) {
    $query .= "$column " . $DBstruct[$table][$column][0] . ",";
  }
  # get rid of the last ,
  $query = substr($query,0,-1);
  $query .= "\n)";

  # submit it to the database
  echo "Initialising table <b>$table</b>";
  if (!isset($force) && Sql_Table_Exists($tables[$table])) {
    Error( 'Table already exists<br />');
	  echo ".. failed<br />\n";
    $success = 0;
  } else {
    $res = Sql_Query($query,0);
    $error = Sql_Has_Error($database_connection);
    $success = $force || ($success && !$error);
		if (!$error || $force) {
      if ($table == "admin") {
        # create a default admin
        Sql_Query(sprintf('insert into %s values(0,"%s","%s","%s",now(),now(),"%s","%s",now(),%d,0)',
          $tables["admin"],"admin","admin","",$adminname,"phplist",1));
      } elseif ($table == "task") {
        while (list($type,$pages) = each ($system_pages)) {
          foreach ($pages as $page => $access_level)
            Sql_Query(sprintf('replace into %s (page,type) values("%s","%s")',
              $tables["task"],$page,$type));
        }
      }

      echo ".. ok<br />\n";
    }
    else
		  echo ".. failed<br />\n";
  }
}
#

if ($success) {
  # mark the database to be our current version
  Sql_Query(sprintf('replace into %s (item,value,editable) values("version","%s",0)',
    $tables["config"],VERSION));
  # add a testlist
	$info = 'List for testing. I you don\'t make this list live and add yourself as a member, you can use this list to test a message. If the message comes out ok, you can resend it to other lists.';
  $result = Sql_query("insert into {$tables["list"]} (name,description,entered,active,owner) values(\"test\",\"$info\",now(),0,1)");
  $body = '
  	Version: '.VERSION."\r\n".
   ' Url: '.getConfig("website").$pageroot."\r\n";
  printf('<p>Success: <a href="mailto:phplist@tincan.co.uk?subject=Successful installation of PHPlist&body=%s">Tell us about it</a>. </p>', $body);
  print "<p>Continue with ".PageLink2("setup","PHPlist Setup")."</p>";
} else {
 print ('<ul><li>Maybe you want to '.PageLink2("upgrade","Upgrade").' instead?
    <li>'.PageLink2("initialise","Force Initialisation","force=yes").' (will erase all data!)'."</ul>\n");
}

?>
