<?php

###############################################################################
## Soholaunch(R) Site Management Tool
## Version 4.5
##      
## Author: 			Mike Johnston [mike.johnston@soholaunch.com]                 
## Homepage:	 	http://www.soholaunch.com
## Bug Reports: 	http://bugzilla.soholaunch.com
## Release Notes:	sohoadmin/build.dat.php
###############################################################################

##############################################################################
## COPYRIGHT NOTICE                                                     
## Copyright 1999-2003 Soholaunch.com, Inc.  All Rights Reserved.       
##                                                                        
## This script may be used and modified in accordance to the license      
## agreement attached (license.txt) except where expressly noted within      
## commented areas of the code body. This copyright notice and the comments  
## comments above and below must remain intact at all times.  By using this 
## code you agree to indemnify Soholaunch.com, Inc, its coporate agents   
## and affiliates from any liability that might arise from its use.                                                        
##                                                                           
## Selling the code for this program without prior written consent is       
## expressly forbidden and in violation of Domestic and International 
## copyright laws.  		                                           
###############################################################################

###
### PAGE BUILDER FOR SOHOLAUNCH MGT. TOOL 
### ----------------------------------------------
###
### VERY IMPORTANT DEVELOPER NOTE: WHEN ADDING OR MODIFING THIS SCRIPT,
### DO NOT USE COMMON VARIABLE NAMES SUCH AS $x, $y, ETC.  THE REASON
### IS THAT THE APPLICATION ALLOWS CUSTOM PHP INCLUDES TO BE EXECUTED
### IN REAL-TIME FROM THE APP INTERFACE.  THEREFORE, IF AN INCLUDE USES
### THESE VARIABLES FOR EXECUTION, IT WILL CAUSE THIS SCRIPT TO CRASH
### BECAUSE THE VARIABLES WILL CONFLICT WITH EACH OTHER!
###

// ----------------------------------------------------------------------
// For eCommerce Tracking throughout the site, we assign the session id
// to a customer number variable for every visitor as a tracking device.
// This was the "old school" way, but with 3.5 release, we are using
// sessions to track orders, therefore, other than the $eID technique
// (described below) the actual customer number variable is obsolete.
// ----------------------------------------------------------------------
// DEVNOTE: The $eID variable has been installed to track quixstar 
// purchase transactions.  The $eID would be passed to the site
// from quixstar (ie: http://mywebsite.com/index.php?eID=134234234)
// ----------------------------------------------------------------------

if ($eID != "") { 
	$customernumber = "quixstar_".$eID; 
}

if ($customernumber == "") {
	for ($x=1;$x<=5;$x++) {
		$customernumber .= rand(0,999);
	}
} // End assign cust_num

if (!session_is_registered("customernumber")) { session_register('$customernumber'); }

// ----------------------------------------------------------------------
// Create sterilize phone number function.
// This function makes sure that all phone numbers entered into input
// boxes are formated the same way each time (pretty cool).
// ----------------------------------------------------------------------

function sterilize_phone ($sterile_var) {
	$sterile_var = eregi_replace("\.", "", $sterile_var);
	$st_l = strlen($sterile_var);
	$st_a = 0;
	$tmp = "";
	while($st_a != $st_l) {
		$temp = substr($sterile_var, $st_a, 1);
		if (eregi("[0-9]", $temp)) { $tmp .= $temp; }
		$st_a++;
	}
	$sterile_var = $tmp;
	$acode = substr($sterile_var, 0, 3);
	$prefix = substr($sterile_var, 3, 3);
	$suffix = substr($sterile_var, 6, 4);
	$thisNum = $acode.$prefix.$suffix;
	$sterile_var = $thisNum;
	
	return $sterile_var;
}

########################################################################
### DEFINE REAL-TIME VARIABLE DATA NEEDED
########################################################################

$thisYear = date("Y");

########################################################################
### DEFINE BUILT-IN JAVASCRIPT AND STYLE SHEET DATA	
### All custom HTML inserts and/or templates can utilize these built-in
### Javascript functions.  Do not remove these because all modules such
### as the shopping cart, etc. utilize these as a shortcut.
########################################################################

$javascript = "\n\n<script language=Javascript>\n<!--\n\n";

$javascript .= "function killErrors() {\n";
$javascript .= "     return true; \n";
$javascript .= "}\n";
$javascript .= "window.onerror = killErrors;\n\n";

$javascript .= "function MM_reloadPage(init) {  // reloads the window if Nav4 resized\n";
$javascript .= "     if (init==true) with (navigator) {if ((appName==\"Netscape\")&&(parseInt(appVersion)==4)) {\n";
$javascript .= "          document.MM_pgW=innerWidth; document.MM_pgH=innerHeight; onresize=MM_reloadPage; }}\n";
$javascript .= "     else if (innerWidth!=document.MM_pgW || innerHeight!=document.MM_pgH) location.reload();\n";
$javascript .= "}\n";
$javascript .= "MM_reloadPage(true);\n\n";

$javascript .= "function MM_swapImgRestore() { //v3.0\n";
$javascript .= "     var i,x,a=document.MM_sr; for(i=0;a&&i<a.length&&(x=a[i])&&x.oSrc;i++) x.src=x.oSrc;\n";
$javascript .= "}\n\n";
$javascript .= "function MM_preloadImages() { //v3.0\n";
$javascript .= "     var d=document; if(d.images){ if(!d.MM_p) d.MM_p=new Array();\n";
$javascript .= "     var i,j=d.MM_p.length,a=MM_preloadImages.arguments; for(i=0; i<a.length; i++)\n";
$javascript .= "     if (a[i].indexOf(\"#\")!=0){ d.MM_p[j]=new Image; d.MM_p[j++].src=a[i];}}\n";
$javascript .= "}\n\n";
$javascript .= "function MM_findObj(n, d) { //v3.0\n";
$javascript .= "     var p,i,x;  if(!d) d=document; if((p=n.indexOf(\"?\"))>0&&parent.frames.length) {\n";
$javascript .= "     d=parent.frames[n.substring(p+1)].document; n=n.substring(0,p);}\n";
$javascript .= "     if(!(x=d[n])&&d.all) x=d.all[n]; for (i=0;!x&&i<d.forms.length;i++) x=d.forms[i][n];\n";
$javascript .= "     for(i=0;!x&&d.layers&&i<d.layers.length;i++) x=MM_findObj(n,d.layers[i].document); return x;\n";
$javascript .= "}\n\n";
$javascript .= "function MM_swapImage() { //v3.0\n";
$javascript .= "     var i,j=0,x,a=MM_swapImage.arguments; document.MM_sr=new Array; for(i=0;i<(a.length-2);i+=3)\n";
$javascript .= "     if ((x=MM_findObj(a[i]))!=null){document.MM_sr[j++]=x; if(!x.oSrc) x.oSrc=x.src; x.src=a[i+2];}\n";
$javascript .= "}\n\n";
$javascript .= "function MM_openBrWindow(theURL,winName,features) { //v2.0\n";
$javascript .= "     window.open(theURL,winName,features);\n";
$javascript .= "}\n\n";
$javascript .= "if (document.styleSheets) { // Fix Netscape Style Sheet Problems\n";
$javascript .= "     if (document.styleSheets.length > 0) {\n";
$javascript .= "	        var siteStyles = document.styleSheets[0];\n";
$javascript .= " 	        siteStyles.addRule(\"cinput\", \"font-size:9pt; height:18px; width:100px;\");\n";
$javascript .= "     }\n";
$javascript .= "}\n\n";
$javascript .= "function mouse_capture() {\n";
$javascript .= "		// This is here to make it easier to login to admin section\n";
$javascript .= "		var thisKey = event.keyCode;\n";
$javascript .= "		 if (thisKey == 113) { \n";
$javascript .= "			// window.location = \"http://$this_ip/sohoadmin/index.php\";\n";
$javascript .= "			window.open(\"http://$this_ip/sohoadmin/index.php?keystroke=on\",\"adminlogin\",\"width=425,height=250,resizable=yes,scrollbars=yes\");\n";
$javascript .= "			return;\n";
$javascript .= "		}\n";
$javascript .= "} // End Func \n\n";

########################################################################
### SOME MODULES RETURN VARIABLE FLAGS THAT CONFIRM TO THE END USER
### THAT AN ACTION HAS BEEN COMPLETED.  THESE INSERTS ARE CREATED
### IN JAVASCRIPT, REAL-TIME, BASED ON VARIABLES PAST BACK FROM THE
### VARIOUS MODULES.  DO NOT REMOVE THESE FOR PROPER PERFORMANCE.
########################################################################

if ($emailsent == 1) {
	$javascript .= "alert(\"Your message has been sent.  Thank you\");\n\n";
}

if ($epagesent == 1) {
$javascript .= "alert(\"This page has been emailed to your friend! Thank you!\");\n\n";
}

########################################################################
### END JAVASCRIPT INSERTION
########################################################################

$javascript .= "-->\n</script>\n\n";

########################################################################
### DEFINE BASE STYLESHEET FOR ALL PAGES GENERATED TO UTILIZE. THIS
### CAN BE MODIFIED FOR TEMPLATES TO USE AS WELL ON A SITE BY SITE BASIS
########################################################################

$stylesheet = "\n\n<LINK rel=\"stylesheet\" href=\"runtime.css\" type=\"text/css\">\n";

########################################################################
### IF USING THE DATABASE MODULE, A DATABASE STYLE SHEET WILL BE COPIED
### TO THE DOC_ROOT.  THEREFORE, IT MUST BE ADDED SO THAT THE DATABASE
### MODULE CAN UTILIZE FOR SPECIFIC DISPLAY NEEDS.
########################################################################

if (file_exists("database.css")) {
	$stylesheet .= "<LINK rel=\"stylesheet\" href=\"database.css\" type=\"text/css\">\n\n";
}

########################################################################
### BUILD USER DEFINED META-TAG DATA HEADERS AS DEFINED IN THE
### "Options & Settings" MAIN MENU OPTION OF THE APPLICATION			
########################################################################


$filename = "$cgi_bin/meta.conf";

if (file_exists("$filename")) {
	$file = fopen("$filename", "r");
		$body = fread($file,filesize($filename));
	fclose($file);
	$lines = split("\n", $body);
	$numLines = count($lines);
	for ($xedusvar=0;$xedusvar<=$numLines;$xedusvar++) {
		$temp = split("=", $lines[$xedusvar]);
		$variable = $temp[0];
		$value = $temp[1];
		${$variable} = $value;
	}

} else {

	// -----------------------------------------------------------------------
	// If user has not set any keywords or descriptive text, then let's take
	// this opportunity to make a shameless plug for our product
	// -----------------------------------------------------------------------

	$site_description = "$SERVER_NAME: Built using the Soholaunch Site Management Solution";
	$site_keywords = "$SERVER_NAME, Soholaunch, Application, Software, Thin-Client";
}

$metatag = "<META http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\n";
$metatag .= "<META name=\"resource-type\" content=\"document\">\n";
$metatag .= "<META name=\"description\" content=\"$site_description\">\n"; 
$metatag .= "<META name=\"keywords\" content=\"$site_keywords\">\n";
$metatag .= "<META name=\"distribution\" content=\"global\">\n";
$metatag .= "<META name=\"copyright\" content=\"(c) $SERVER_NAME $thisYear.  All rights reserved.  Technology Powered by Soholaunch.com\">\n";

########################################################################
### PULL HEADER INFORMATION FOR #LOGO# TEMPLATE VAR	
### This only applies if using a built-in template that has a #LOGO# var
########################################################################

$filename = "$cgi_bin/logo.conf";
if (file_exists("$filename")) {
	$file = fopen("$filename", "r");
		$body = fread($file,filesize($filename));
	fclose($file);
	$lines = split("\n", $body);
	$numLines = count($lines);
	for ($xedusvar=0;$xedusvar<=$numLines;$xedusvar++) {
		$temp = split("=", $lines[$xedusvar]);
		$variable = $temp[0];
		$value = $temp[1];
		$value = stripslashes($value);
		${$variable} = $value;
	}

} else {

	$tmp = ucwords($SERVER_NAME);
	$headertext = "$tmp Coming Soon";
	$subheadertext = "";
}

########################################################################
### THE PAGE REQUEST WAS SENT TO US VIA $pageRequest OR $pr DEPENDING
### ON THE MODULE ACCESSING THE index.php FILE.  LET'S GET THAT INFO
### FROM OUR site_pages DATABASE TABLE.  IF NO PAGE REQUEST DATA WAS
### SENT TO THE SCRIPT, WE ARE ASSUMING THIS IS A FIRST TIME HIT AND WE
### WILL RETURN THE HOME PAGE BY DEFAULT.					
########################################################################

// STEP 1: Make Sure All First Letters Are Upper Case In Var and Spaces are eliminated
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

$pageRequest = eregi_replace("_", " ", $pageRequest); // You have to do this because some people are idiots
$pageRequest = eregi_replace(" ", "_", $pageRequest);

// STEP 2: If PR var is empty, assign it to the Home Page
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

if ($pageRequest == "") { $pageRequest = "Home_Page"; }

// STEP 3: Define if the page is being called by internal link or not.
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// DEVNOTE: Each page created in the system is assigned a primary key number that is
// used to access pages from within modules and content areas. (This is the key to
// making the word processor work properly in the page editor)
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

$filename = "$cgi_bin/$pageRequest.con";

if (!file_exists("$filename")) {	// This page must have been called by the PriKey

	$result = mysql_query("SELECT page_name, username, password, splash FROM site_pages WHERE link = '$pageRequest'");
	$tmp = mysql_num_rows($result); // In case underscore is used when actually creating a page
	if ($tmp <= 0) {
		$newSqlQuery = $pageRequest;
		$result = mysql_query("SELECT page_name, username, password, splash FROM site_pages WHERE page_name = '$newSqlQuery'");
	}
	
	while ($row = mysql_fetch_array ($result)) {

		$pageRequest = $row["page_name"];
		$security_code = $row[username];	// Does this page require Authentication?
		$page_template = $row["password"];	
		$splashpage = $row["splash"];
	}

	$pageRequest = eregi_replace(" ", "_", $pageRequest);

} else {

	$thisPage = eregi_replace("_", " ", $pageRequest);
	$result = mysql_query("SELECT page_name, username, password, splash FROM site_pages WHERE page_name = '$thisPage'");
	$tmp = mysql_num_rows($result);	// In case underscore is used when actually creating a page
	if ($tmp <= 0) {
		$newSqlQuery = $pageRequest;
		$result = mysql_query("SELECT page_name, username, password, splash FROM site_pages WHERE page_name = '$newSqlQuery'");
	}
	
	while ($row = mysql_fetch_array ($result)) {

		$pageRequest = $row["page_name"];
		$security_code = $row[username];	// Does this page require Authentication?
		$page_template = $row["password"];
		$splashpage = $row["splash"];

	}

	$pageRequest = eregi_replace(" ", "_", $pageRequest);

}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// We have new pageRequest name if available.  Let's make sure this is page that has
// been created within the page editor or if content exists
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

$filename = "$cgi_bin/$pageRequest.con";

// STEP 4: Determine if this page has been created by the user yet
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

if (!file_exists("$filename")) {	// Page content does not exist

	$error = 404;
	$content_line = "";
	$numlines = 0;

	// **********************************************************************
	// At this point, we have found this page to not be present
	// at all or "yet", so we do an under construction display for content.
	// **********************************************************************

	$errordisplay = "<table border=0 cellpadding=10 cellspacing=0 width=500><tr><td align=center valign=top>\n";
	$errordisplay .= "<img src=under_construction.gif  width=273 height=74  border=0></td></tr></table><BR>&nbsp;<BR>\n";

} else {					// Page does exist; get the content HTML

	$file = fopen("$filename", "r");
		$body = fread($file,filesize($filename));
	fclose($file);

	$content_line = split("\n", $body);	// We have just placed the content HTML into the $content_line Array.
	$numlines = count($content_line);	// $numlines is now equal to the number of lines in the content HTML

}


// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// STEP 5: Does Page Require Authentication 
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

$SECURE_OK = 0;
if (eregi("$security_code", $GROUPS)) { $SECURE_OK = 1; }
if (strlen($security_code) > 3 && $SECURE_OK == 0) {	

	// If so, then this page needs security authentication before it can be accessed.
	// The authentication routine is built as an include so that we can make sure
	// that the authentication works on both Apache compiled PHP and CGI PHP.
	// Plus, we don't need all that code if no auth is required. It will make our
	// script run faster.
	
	include("pgm-authenticate.php");

}

##############################################################################
### SETUP BASE TEMPLATE HTML AS ASSIGNED IN "Site Template(s)" MENU OPTION.
### NOW THAT WE HAVE THE CONTENT HTML PLACED INTO THE $content_line 
### ARRAY, LET'S GET THE TEMPLATE HTML AND PLACE IT INTO AN ARRAY AS
### WELL SO THAT WE CAN PROCESS ALL THE HTML THROUGH THE "BUILD INTERPRETER"			
##############################################################################	

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// STEP 1: Define template html in template_line var
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

if (strlen($page_template) > 5 && eregi("CT:", $page_template)) {

	$body = "CUSTOM";
	$tVal[1] = $page_template;

} else {

	$filename = $WIN_FULL_PATH."template/template.conf";
	
	$file = fopen("$filename", "r");
		$body = fread($file,filesize($filename)); 
	fclose($file);

	// ************************************************************************
	// Split the #CONTENT# var to an individual line so that we know nothing
	// else will be on that line when we start looping through the template
	// html array.  This is important because we do not want to screw up the
	// formating that you, the programmer, have put into the template.
	// We are also going to add a spacer above and below the content area. Some
	// site developers may want to remove these spacers for tighter control
	// over the aspect ratio of the content area.
	// However, the line feeds are CRUCIAL to operation, DO NOT REMOVE THOSE!
	// ************************************************************************

	$newContentVar = "\n#CONTENT#\n";

	$body = eregi_replace("#CONTENT#", "$newContentVar", $body);
	$tVal = split("~~~", $body);
	$tVal[1] = eregi_replace("\n", "", $tVal[1]);

}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// STEP 1a: This page may in fact have a specific individual template assigned to it
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

// ************************************************************
// In case our assumption in the next line is not true, 
// we have to circle back and use the base template.
// So, let's create a temp var to hold our base template code.
// ************************************************************

$bombCode = $body;	

// ************************************************************
// Until we know for sure, let's force the assumption that
// that we are going to use a custom template.
// ************************************************************

$body = "CUSTOM";

// ************************************************************
// Now, define whether or not this specific page request has a
// custom template defined for it, or, are we using the base
// template for all pages within this site?
// ************************************************************

include("pgm-page_templates.php");

// --------------------------------------------------------
// Is this an enewsletter generation request? Is so, use
// the template assigned by the build generator to process
// this script
// --------------------------------------------------------

if ($news_force_template != "") {
	$body = "CUSTOM";
	$tVal[1] = $news_force_template;
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// STEP 1b: If this is NOT a custom template selection, pull base tempalte and ready data
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



if (!eregi("CUSTOM", $body)) {

	$directory = $WIN_FULL_PATH."template";
	$handle = opendir("$directory");

	while ($files = readdir($handle)) {
		if (strlen($files) > 2) {
			if (eregi(".html", $files) || eregi(".htm", $files)) { $template = $files; } 
		}
	}
	closedir($handle);

	$filename = $WIN_FULL_PATH."template/$template";

	$file = fopen("$filename", "r");
		$tbody = fread($file,filesize($filename));
	fclose($file);


	$tbody = eregi_replace("#CONTENT#", "\n#CONTENT#\n", $tbody);
	$template_line = split("\n", $tbody);
	
	$numtlines = count($template_line);
	
	for ($xedusvar=0;$xedusvar<=$numtlines;$xedusvar++) {
		if (eregi("<body", $template_line[$xedusvar])) {
			$bodytag = eregi("<body(.*)>", $template_line[$xedusvar], $out);
			$bodytag = "<body " . $out[1] . ">";
		}
	}

	$CustomFlag = 0;

} else {

	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	// STEP 1c: If this IS a custom template selection, pull base tempalte and ready data
	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	$filename = $WIN_FULL_PATH."tCustom/$tVal[1]";

	if (!file_exists("$filename")) { $filename = "media/$tVal[1]"; }

	$file = fopen("$filename", "r");
		$tbody = fread($file,filesize($filename));
	fclose($file);

	$tbody = eregi_replace("#CONTENT#", "\n#CONTENT#\n", $tbody);

	$template_line = split("\n", $tbody);
	$numtlines = count($template_line);

	for ($xedusvar=0;$xedusvar<=$numtlines;$xedusvar++) {

		if (eregi("<body", $template_line[$xedusvar])) {
			$bodytag = eregi("<body(.*)>", $template_line[$xedusvar], $out);
			$bodytag = "<body " . $out[1] . ">";
		}

		// *************************************************************	
		// Put SRC and BACKGROUND tags pointed to the images directory
		// *************************************************************

		$template_line[$xedusvar] = eregi_replace("amp;", "", $template_line[$xedusvar]);
		$template_line[$xedusvar] = eregi_replace("src=\"", "src=\"images/", $template_line[$xedusvar]);
		$template_line[$xedusvar] = eregi_replace("background=\"", "background=\"images/", $template_line[$xedusvar]);

	}
	
	$CustomFlag = 1;
} 

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// STEP 2: Finally, none of the template data matters if this page has been classified
// as a splash page from the page properties settings.
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

if ($splashpage == "y" && $module_active != "yes") {

	if ($splash_bg == "") { $splash_bg = "white"; }	// In case no setting exists

	// *********************************************************************
	// Open runtime.css to see if .bg has been placed inside
	// style sheet call (this can control a BODY style for the splash page).
	// *********************************************************************

	$filename = $WIN_FULL_PATH."runtime.css";

	$file = fopen("$filename", "r");
		$csbody = fread($file,filesize($filename));
	fclose($file);

	if (eregi("\.bg", $csbody)) {
		$classify = "class=\"bg\"";
		$centertag = "no";

		if (eregi("sohoalign", $csbody)) {
			$centertag = "yes";
			$classify = "class=\"bg\"";
		}

	} else {

		$centertag = "yes";
		$classify = "bgcolor=$splash_bg";

	}

	$site_title = stripslashes($site_title);

	// *********************************************************************
	// CREATE THE SPLASH PAGE TEMPLATE HTML (VERY SIMPLE AND DIRECT)
	// *********************************************************************

	$template_line[0] = "<HTML>";
	$template_line[1] = "<HEAD>";
	$template_line[2] = "<TITLE>$site_title</TITLE>\n";
	$template_line[3] = "\n<!-- SPLASH PAGE -->\n\n";
	$template_line[4] = "</HEAD>\n";
	$template_line[5] = "<body marginheight=0 marginwidth=0 topmargin=0 leftmargin=0 $classify>\n";

	if ($centertag == "yes") {
		$template_line[5] .= "<CENTER>\n";
	}

	$template_line[6] = "#CONTENT#";

	$template_line[7] = "</body></html>\n";

	$numtlines = 7;

}

// ***************************************************************************************
// DEVNOTE: At this point, the template HTML is housed in the $template_line[] array and
// the content HTML is housed in the $content_line[] array.
// ***************************************************************************************

##############################################################################
### DEFINE USE OF AUTO-MENU SYSTEM // IF NOT USING, DISREGARD, ELSE INCLUDE
### THE MENU CREATION ROUTINE AND BUILD DYNAMIC MENU SYSTEM.  THIS IS AN
### INCLUDE BECAUSE 90% OF THE SITES BUILT UTILIZE A CUSTOM TEMPLATE WITH
### SOME TYPE OF CUSTOM NAVIGATION STRUCTURE.  THEREFORE, THIS CODE SIMPLY
### SLOWS THE GENERATION OF THE PAGES DOWN IF THEY ARE NOT USING IT.
##############################################################################	

// STEP 1: IS THIS TEMPLATE USING A "#HMENU#", "#VMENU" OR "#TMENU#" VARIABLE?
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

$auto_menu_on = "no";

for ($menu_chk=0;$menu_chk<=$numtlines;$menu_chk++) {

	if (eregi("#HMENU#", $template_line[$menu_chk])) { $auto_menu_on = "yes"; }
	if (eregi("#VMENU#", $template_line[$menu_chk])) { $auto_menu_on = "yes"; }
	if (eregi("#TMENU#", $template_line[$menu_chk])) { $auto_menu_on = "yes"; }

}

if ($auto_menu_on == "yes") {

	include("pgm-auto_menu.php");

}


#######################################################################################
### DEFINE template_header AND template_footer variable TO SEND BACK
### TO index.php. THIS IS WHERE WE START WORKING ON THE DYNAMIC ELEMENTS
### OF THE CONTENT AND TEMPALTE HTML, INSERTING DATA WHERE NEEDED AND
### MODIFING THE HTML FOR FINAL OUTPUT
#######################################################################################

$switchvar = 0;			// This will determine when we switch from header to footer

$template_header = "";		// Start header blank
$template_footer = "";		// Start footer blank


// ******************************************************************
// Start "xedusvar" loop through template HTML code now (outer loop)
// ******************************************************************

for ($xedusvar=0;$xedusvar<=$numtlines;$xedusvar++) {


	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	// Parse Outdated Variables.  These could be used if you wish to add other variables
	// to the template for interpretation.  Simply replace these with the HTML code that
	// you wish to put in place of the "variable" call. 
	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	$template_line[$xedusvar] = eregi_replace("#poweredby#", "", $template_line[$xedusvar]);
	$template_line[$xedusvar] = eregi_replace("#cart#", "", $template_line[$xedusvar]);

	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	// Place current year in place of #YEAR# variable (Added June 2002)
	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	$TROT = date("Y");
	$template_line[$xedusvar] = eregi_replace("#YEAR#", "$TROT", $template_line[$xedusvar]);

	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	// Replace all "input type submit" tags with the proper style sheet class defined
	// in the runtime.css file.
	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	$template_line[$xedusvar] = eregi_replace("input type=submit", "input type=submit class=FormLt1", $template_line[$xedusvar]);
	$template_line[$xedusvar] = eregi_replace("input type=\"submit\"", "input type=submit class=FormLt1", $template_line[$xedusvar]);

	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	// If Not a Custom Template, Make Sure all Template Images are pulled from Template 
	// since they will be moved there when base template is selected.
	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	if ($CustomFlag == 0) {
		$template_line[$xedusvar] = eregi_replace("img src=\"", "img src=\"template/", $template_line[$xedusvar]);
		$template_line[$xedusvar] = eregi_replace("background=\"", "background=\"template/", $template_line[$xedusvar]);
	}

	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	// Insert User Defined Page Title and Meta Tags into display of HTML
	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	$site_title = stripslashes($site_title);

	if ($site_title == "") { $site_title = $SERVER_NAME; }

	$template_line[$xedusvar] = eregi_replace("<title>(.*)</title>", "<title>$site_title</title>\n\n", $template_line[$xedusvar]);

	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	// If "force_link" var == YES : Force all Links on page to maroon for easy viewing
	// This variable is pushed to this module from the calendar module. Because of the
	// white background display of the calendar, we want to make sure that any link colors
	// specified in the template do not make the calendar unreadable.
	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	if ($force_link == "yes") {

		$modbgcolor = "FFFFFF";

		if (eregi("<body", $template_line[$xedusvar])) {

			$calendarline = $template_line[$xedusvar];
			$fi = split(" ", $calendarline);

			$nfi = count($fi);
			$newline = "";

			for ($cl=0;$cl<=$nfi;$cl++) {
				$doneit = 0;
				if (eregi("link=", $fi[$cl])) { $newline .= " link=maroon "; $doneit = 1; }
				if (eregi("alink=", $fi[$cl])) { $newline .= " alink=maroon "; $doneit = 1; }
				if (eregi("vlink=", $fi[$cl])) { $newline .= " vlink=maroon "; $doneit = 1; }
				if (eregi("text=", $fi[$cl])) { $newline .= " text=black "; $doneit = 1; }
				if ($doneit == 0) { $newline .= " $fi[$cl] "; }
			}

			$template_line[$xedusvar] = $newline;

		}

	} // End if "force_link" is on

	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	// Insert Javascript and Style Sheet info defined in the beginning of this script
	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	// Changed 2003-03-03 to place meta data above </head> tag (was above </body> tag)	
	if (eregi("</head", $template_line[$xedusvar])) {
		$template_line[$xedusvar] = "\n\n" . $metatag . "\n\n" . $stylesheet . "\n\n<!-- $site_keywords -->\n\n" . $javascript . "\n<!-- Site Powered By Soholaunch.com -->\n\n" .$template_line[$xedusvar];
	}

	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	// Place Text Menu into Template
	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	if (eregi("#TMENU#", $template_line[$xedusvar])) {
		$tmenu = "";
		if ($textmenu == "on") {
			$tmenu = "<div align=center><font size=1 face=Arial, Helvetica, Sans-Serif><BR><B>[ $main_textmenu ]<BR></B></font></div>";
		}
		$tmenu = eregi_replace("\|  ]", "]", $tmenu);
		$template_line[$xedusvar] = eregi_replace("#TMENU#", $tmenu, $template_line[$xedusvar]);
	}

	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	// Place Horizontal Button Menu into Template
	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	if (eregi("#HMENU#", $template_line[$xedusvar])) {
		$horizmenu = "";
		if ($mainmenu != "vertical") {
			$horizmenu = $main_buttons;
		}

		$horizmenu = "\n\n<!-- START AUTO MENU SYSTEM -->\n\n" . $horizmenu . "\n\n<!-- END AUTO MENU SYSTEM -->\n\n";
		$template_line[$xedusvar] = eregi_replace("#HMENU#", $horizmenu, $template_line[$xedusvar]);
	}


	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	// PLACE CUSTOM INCLUDE SCRIPT INTO TEMPLATE (Filename Must be template_include.inc)
	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	if (eregi("#CUSTOMPHP#", $template_line[$xedusvar])) {
		$custom_include = "";
		$filename = "media/template_include.inc";
		if (file_exists($filename)) {
			ob_start(); 
			include("$filename");
			$custom_include = ob_get_contents(); 
			ob_end_clean(); 
		}
		$template_line[$xedusvar] = eregi_replace("#CUSTOMPHP#", $custom_include, $template_line[$xedusvar]);
	}

	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	// Place Vertical Button Menu into Template
	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	if (eregi("#VMENU#", $template_line[$xedusvar])) {
		$vertmenu = "";
		if ($mainmenu == "vertical") {
			$vertmenu = $main_buttons;
		} else {
			$vertmenu = $sub_buttons;
		}

		$vertmenu = "\n\n<!-- START AUTO MENU SYSTEM -->\n\n" . $vertmenu . "\n\n<!-- END AUTO MENU SYSTEM -->\n\n";
		$template_line[$xedusvar] = eregi_replace("#VMENU#", $vertmenu, $template_line[$xedusvar]);
	}
	
	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	// INSERT CODE FOR PHP INCLUDE SCRIPT
	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	if (eregi("##PHPINCLUDE;", $template_line[$xedusvar])) {

		$temp = eregi("<!-- ##PHPINCLUDE;(.*)## -->", $template_line[$xedusvar], $out);
		$INCLUDE_FILE = $out[1];

		$filename = "media/$INCLUDE_FILE";
	
		// Inserted for V5.  Makes it easier to add new objects to object bar in editor
		if (eregi("pgm-", $INCLUDE_FILE)) { $filename = "$INCLUDE_FILE"; }
		
		$output = "";
		ob_start(); 
			include("$filename");
			$output = ob_get_contents(); 
		ob_end_clean(); 

		$template_line[$xedusvar] = "\n\n<!-- ~~~~~~~ CUSTOM PHP TEMPLATE OUTPUT ~~~~~~ -->\n\n" . $output . "\n\n<!-- ~~~~~~~~~~~~ END CUSTOM PHP TEMPLATE OUTPUT ~~~~~~~~~~~~ -->\n\n";
	
	}

	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	// Place Logo Var Header Information
	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	if (eregi("#LOGO#", $template_line[$xedusvar])) {
		$logo = "$headertext";
		
		// "<BR><font size=2><span class=logosubhead>$subheadertext</span></font>\n";
		
		$template_line[$xedusvar] = eregi_replace("#LOGO#", $logo, $template_line[$xedusvar]);
	}

	$template_line[$xedusvar] = eregi_replace("#DOTCOM#", $dot_com, $template_line[$xedusvar]);

	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	// Place Autmatic Date Stamp into Template
	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	if (eregi("#AUTODATESTAMP#", $template_line[$xedusvar])) {
		$tmp = date("l, F j, Y");
		$template_line[$xedusvar] = eregi_replace("#AUTODATESTAMP#", $tmp, $template_line[$xedusvar]);
	}

##############################################################################################
### WHILE $xedusvar LOOP IS STILL IN MOTION; START LOOPING THROUGH CONTENT HTML
### THAT WAS CREATED FROM THE PAGE EDITOR AND START INSERTING REAL-TIME DATA INTERPRETATION
### FOR FINAL OUTPUT.
##############################################################################################


	if (eregi("#CONTENT#", $template_line[$xedusvar])) {

		$switchvar = 1;	// The Content Variable indicates the switch from header to footer


		// ***************************************************************************************
		// In case of troubleshooting needs, lets place some HTML comment code to indicate where
		// the actual page_content starts that was created by the page editor system
		// ***************************************************************************************

		$pagecontent = "\n\n\n\n<!-- \n\n";
		$pagecontent .= "###########################################################################\n";
		$pagecontent .= "### PGM-REALTIME-BUILDER ==> START PAGE CONTENT FROM CONTENT EDITOR \n";
		$pagecontent .= "###########################################################################\n\n";
		$pagecontent .= "-->\n\n\n\n";


		// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		// If we have determined a 404 error for this page (See above content retreival) then
		// place the error display HTML here
		// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

		if ($error == 404 && $module_active != "yes") { $pagecontent .= $errordisplay; }

		// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		// If $module_active is eq "yes", then we have called the builder program from a
		// module, meaning we want to allow the module code to place data in the content
		// area, so we really don't need the content for the "pageRequest", we just need
		// to offer up another #CONTENT# var to the module script.
		// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

		if ($module_active == "yes") { 

			$pagecontent .= "\n\n#CONTENT#\n\n"; 

		} else {

		##############################################################################################
		## START ACTUAL "INNER LOOP" THROUGH CONTENT LINES WITHIN THE $xedusvar LOOP
		##############################################################################################

		for ($sohocontent=0;$sohocontent<=$numlines;$sohocontent++) {

			
			// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			// INSERT CODE FOR AUTOMATIC DATE STAMP
			// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

			if (eregi("<!-- ##PHPDATE## -->", $content_line[$sohocontent])) {
				$today = date("F j, Y");
				$content_line[$sohocontent] = eregi_replace("<!-- ##PHPDATE## -->", "<font face=Verdana, Arial, Helvetica size=2><B>$today</B></font>", $content_line[$sohocontent]);
			}
			
			if (eregi("#DATE#", $content_line[$sohocontent])) {
				$today = date("F j, Y");
				$content_line[$sohocontent] = eregi_replace("#DATE#", "$today", $content_line[$sohocontent]);
			}

			// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			// INSERT CODE FOR HIT COUNTER CALCULATION AND DISPLAY
			// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

			if (eregi("##COUNTER##", $content_line[$sohocontent])) {
			
				$filename = $WIN_FULL_PATH."hitcounter.txt";
				
				if (file_exists("$filename")) {
				
					$file = fopen("$filename", "r");
						$hitcount = fread($file,filesize($filename));
					fclose($file);
					
					$hitcount = eregi_replace("\n", "", $hitcount);
					$hitcount = chop($hitcount);
					$hitcount = ltrim($hitcount);
					$hitcount = rtrim($hitcount);
					
				} else {
				
					$hitcount = "1";
					
				}
				
				// Build Graphical representation of counter number for display
				
				$hit_count_graphic = "";
				
				$tmp = strlen($hitcount);	// Get number of digits in number
				for ($hc_cnt=0;$hc_cnt<=$tmp;$hc_cnt++) {
					$hc_number = substr($hitcount, $hc_cnt, 1);
					if ($hc_number != "") { $hit_count_graphic .= "<IMG SRC=\"$hc_number.gif\" width=15 height=20 border=0 align=absmiddle vspace=0 hspace=0 border=0>"; }
				}
				
				$content_line[$sohocontent] = "<TABLE BORDER=0 CELLPADDING=2 CELLSPACING=0 ALIGN=CENTER><TR><TD ALIGN=CENTER VALIGN=MIDDLE>\n";
				$content_line[$sohocontent] .= "$hit_count_graphic\n";
				$content_line[$sohocontent] .= "</TD></TR></TABLE>\n";
				
				$hitcount++;
				$file = fopen("$filename", "w");
					fwrite($file, "$hitcount\n");
				fclose($file);
				
			}

			// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			// INSERT CODE FOR REALTIME CALENDAR MODULE
			// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			
			if (eregi("##CALENDAR", $content_line[$sohocontent])) {
			
				$this_mod = str_replace("<!-- ##", "", $content_line[$sohocontent]);
				$this_mod = str_replace("## -->", "", $this_mod);
				
				if (eregi(";", $this_mod)) {
					$tmp = split(";", $this_mod);
					$this_mod = $tmp[0];
					$CHANGE_CAT = $tmp[1];
				}
				
				$this_mod = ltrim($this_mod);
				$this_mod = rtrim($this_mod);
				
				if ($this_mod == "CALENDAR-WEEKLY-VIEW") {
					$filename = "pgm-cal-weekview.php";
				}
				
				if ($this_mod == "CALENDAR-ONEMONTH-VIEW") {
					$filename = "pgm-cal-monthview.php";
				}
				
				if ($this_mod == "CALENDAR-SYSTEM") {
					$filename = "pgm-cal-system.php";
				}
				
				ob_start(); 
					include("$filename");
					$content_line[$sohocontent] = ob_get_contents(); 
				ob_end_clean(); 
			
			}

			// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			// Translate all submit buttons into proper style class
			// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~			
			
			$content_line[$sohocontent] = eregi_replace("input type=submit", "input type=submit class=FormLt1", $content_line[$sohocontent]);
			$content_line[$sohocontent] = eregi_replace("input type=\"submit\"", "input type=submit class=FormLt1", $content_line[$sohocontent]);


			// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			// INSERT CODE FOR SINGLE PRODUCT SKU PROMOTION (REAL-TIME UPDATE) Bugzilla #21
			// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

			if (eregi("<!--##SINGLESKU;", $content_line[$sohocontent])) {
				$tmp = eregi("<!--##SINGLESKU;(.*)##-->", $content_line[$sohocontent], $out);
				$sku_number = $out[1];
				
				include("pgm-single_sku.php");	// Added 2003-09-09
				
				$content_line[$sohocontent] = $SINGLE_SKU_PROMO_HTML;				
				
			} // End Sku Promotion
			
			// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			// INSERT CODE FOR PHP INCLUDE SCRIPT
			// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

			if (eregi("##MIKEINC;", $content_line[$sohocontent])) {

				$temp = eregi("<!-- ##MIKEINC;(.*)## -->", $content_line[$sohocontent], $out);
				$INCLUDE_FILE = $out[1];

				$filename = "media/$INCLUDE_FILE";
				
				// Inserted for V5.  Makes it easier to add new objects to object bar in editor
				if (eregi("pgm-", $INCLUDE_FILE)) { $filename = "$INCLUDE_FILE"; }

				ob_start(); 
				include("$filename");
				$output = ob_get_contents(); 
				ob_end_clean(); 

				$content_line[$sohocontent] = "\n\n<!-- ~~~~~~~ CUSTOM PHP OUTPUT ~~~~~~ -->\n\n" . $output . "\n\n<!-- ~~~~~~~~~~~~ END CUSTOM PHP OUTPUT ~~~~~~~~~~~~ -->\n\n";
			}
			
			
			// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			// INSERT CODE FOR REAL-TIME BLOG READER
			// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			
			if (eregi("##BLOG", $content_line[$sohocontent])) {
				$tmp = eregi("<!-- ##BLOG;(.*)## -->", $content_line[$sohocontent], $out);
				$BLOG_CATEGORY_NAME = $out[1];
				
				$filename = "pgm-blog_display.php";
				ob_start(); 
					include("$filename");
					$content_line[$sohocontent] = ob_get_contents(); 
				ob_end_clean(); 
				
			} // End Blog Display
			
			// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			// INSERT CODE FOR SECURE LOGIN FEATURE
			// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


			if (eregi("<!-- ##SECURELOGIN;", $content_line[$sohocontent])) {
				$tmp = eregi("<!-- ##SECURELOGIN;(.*)## -->", $content_line[$sohocontent], $out);
				$BUTTON_NAME = $out[1];
				
				if ($OWNER_EMAIL != "" && $OWNER_NAME != "") {
				
					$content_line[$sohocontent] = "\n\n<!-- Secure Authentication Login -->\n\n<div align=center>\n";
					$content_line[$sohocontent] .= "<form method=\"post\" action=\"pgm-secure_manage.php\">\n";
					$content_line[$sohocontent] .= "<input type=hidden name=customernumber value=\"$customernumber\">\n";
					$content_line[$sohocontent] .= "<table border=0 cellpadding=5 cellspacing=0 class=border width=199><tr><td align=center valign=top bgcolor=\"#EFEFEF\">\n";
					$content_line[$sohocontent] .= "<input type=submit value=\"Manage Account\" STYLE=\"cursor: hand; font-family: Arial; font-size: 8pt;\"><BR>\n";
					$content_line[$sohocontent] .= "<font size=1 face=Arial, Helvetica>&nbsp;<BR><B>Welcome $OWNER_NAME!\n";
					$content_line[$sohocontent] .= "</td></tr></table>\n</form>\n</div>\n\n\n";
					
				} else {

					$content_line[$sohocontent] = "\n\n<!-- Secure Authentication Login -->\n\n<div align=center>\n";
					$content_line[$sohocontent] .= "<form method=\"post\" action=\"pgm-secure_login.php\">\n";
					$content_line[$sohocontent] .= "<input type=hidden name=customernumber value=\"$customernumber\">\n";
					$content_line[$sohocontent] .= "<table border=0 cellpadding=5 cellspacing=0 class=border width=199><tr><td align=center valign=top bgcolor=\"#EFEFEF\">\n";
					$content_line[$sohocontent] .= "<input type=submit value=\"$BUTTON_NAME\" STYLE=\"cursor: hand; font-family: Arial; font-size: 8pt;\"><BR>\n";
					$content_line[$sohocontent] .= "<font size=1 face=Arial, Helvetica>&nbsp;<BR>Forget your password? <a href=\"pgm-secure_remember.php\">Click Here.</a>\n";
					$content_line[$sohocontent] .= "</td></tr></table>\n</form>\n</div>\n\n\n";
					
				}

			}

			// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			// Add the current loop through the content_line array to the "$pagecontent" var
			// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

			$pagecontent .= $content_line[$sohocontent] . "\n";

		} // END LOOP

		##############################################################################################
		### END OF $sohocontent LOOP
		##############################################################################################

	} // END MODULE-ACTIVE = YES IF STATEMENT

	$pagecontent .= "\n\n\n\n<!-- \n\n";
	$pagecontent .= "##############################################################################\n";
	$pagecontent .= "### PGM-REALTIME-BUILDER ==> END DYNAMIC PAGE CONTENT FROM PAGE EDITOR SYSTEM \n";
	$pagecontent .= "##############################################################################\n\n";
	$pagecontent .= "-->\n\n\n\n";

	$template_line[$xedusvar] = eregi_replace("#CONTENT#", $pagecontent, $template_line[$xedusvar]);

	}

##############################################################################################
### WE HAVE NOW COMPLETED THE "IF '#CONTENT#'" VARIABLE STATEMENT WHILE LOOPING THROUGH
### THE TEMPLATE HTML CODE.  NOW, LETES MAKE SURE THAT WE ARE PASSING PROPER SESSION ID'S
### AND DYNAMIC VARIABLE DATA BETWEEN MODULES BY FORCING CORRECT LINKING WITHIN THE CURRENT
### TEMPLATE LINE. (WHICH CURRENTLY INCLUDES ALL CONTENT JUST INTERPRETED AT THIS POINT).
##############################################################################################

	$template_line[$xedusvar] = eregi_replace("mdatabase.php\?", "mdatabase.php?customernumber=$customernumber&", $template_line[$xedusvar]);
	$template_line[$xedusvar] = eregi_replace("calendar.php\?", "calendar.php?customernumber=$customernumber&", $template_line[$xedusvar]);
	$template_line[$xedusvar] = eregi_replace("shopping.php\?", "shopping.php?customernumber=$customernumber&", $template_line[$xedusvar]);
	$template_line[$xedusvar] = eregi_replace("htdocs/shopping/start.php", "htdocs/shopping/start.php?customernumber=$customernumber", $template_line[$xedusvar]);
	$template_line[$xedusvar] = eregi_replace("href=\"shopping/start.php\?", "href=\"shopping/start.php?customernumber=$customernumber&", $template_line[$xedusvar]);
	$template_line[$xedusvar] = eregi_replace("index.php\?", "index.php?customernumber=$customernumber&", $template_line[$xedusvar]);
	$template_line[$xedusvar] = eregi_replace("pgm-email_friend.php\?", "pgm-email_friend.php?customernumber=$customernumber&", $template_line[$xedusvar]);
	$template_line[$xedusvar] = eregi_replace("</form>","<input type=hidden name=customernumber value=\"$customernumber\">\n</form>\n", $template_line[$xedusvar]);

	// ------------------------------------------------------------------------
	// Add current interpreted line data to header or footer vars respectively
	// ------------------------------------------------------------------------

	if ($switchvar == 1) {
		$template_footer .= $template_line[$xedusvar] . "\n";
	} else {
		$template_header .= $template_line[$xedusvar] . "\n";
	}
	
} // End Template Loop

#################################################################################################
### WE HAVE NOW FINISHED PUTTING THE $template_header AND $template_footer VARIABLES
### TOGETHER AND HAVE COMPLETED BUILDING OUR PAGE DISPLAY HTML!  KOOL HUH?
#################################################################################################

// By license, you can not modify below this line
// -------------------------------------------------

if (eregi("xj17b", $com_key)) {
	$template_footer .= "<CENTER><DIV STYLE='width: 300; background: white; border: 1px inset black;'><FONT SIZE=3 FACE=ARIAL><B>Soholaunch Evaluation Website</B></FONT><BR><FONT FACE=ARIAL><a href=\"http://www.soholaunch.com\">Visit Soholaunch</a></DIV>\n\n";
}

// ----------------------------------------------------------------
// Look For Number of User Addition and do it now -- 4.5 Addition
// ----------------------------------------------------------------

$template_on = 1;
$filename = "pgm-numusers.php";
if (file_exists($filename)) {
	ob_start(); 
		include("$filename");
		$numUserOpt = ob_get_contents(); 
	ob_end_clean(); 
}
		
$template_header = eregi_replace("#USERSONLINE#", $numUserOpt, $template_header);
$template_footer = eregi_replace("#USERSONLINE#", $numUserOpt, $template_footer);
$template_on = 0;

$template_header = eregi_replace("<BODY ", "<BODY onkeydown=\"mouse_capture();\" ", $template_header);

// Added for easy upgrade from V3 to V4 and up
// ------------------------------------------------------------------------------

// $template_header = eregi_replace("php3", "php", $template_header); 
// $template_footer = eregi_replace("php3", "php", $template_footer);  

// ----------------------------------------------------------------
// Pull Global Search and Replace Vars and process now
// ----------------------------------------------------------------

$tResult = mysql_query("SELECT * FROM UDT_CONTENT_SEARCH_REPLACE");
while ($srRow = mysql_fetch_array($tResult)) {
	$repString = $srRow[REPLACE_WITH];
	if ($srRow[AUTO_IMAGE] != "NULL") { $repString = "<img src=\"images/$srRow[AUTO_IMAGE]\" align=absmiddle border=0>"; }
	if (strlen($srRow[SEARCH_FOR]) > 3) {
		$template_header = eregi_replace($srRow[SEARCH_FOR], $repString, $template_header);
		$template_footer = eregi_replace($srRow[SEARCH_FOR], $repString, $template_footer);
	}
} // End While

?>