<?php

###############################################################################
## Soholaunch(R) Site Management Tool
## Version 4.5
##      
## Author: 			Mike Johnston [mike.johnston@soholaunch.com]                 
## Homepage:	 	http://www.soholaunch.com
## Bug Reports: 	http://bugzilla.soholaunch.com
## Release Notes:	sohoadmin/build.dat.php
###############################################################################

##############################################################################
## COPYRIGHT NOTICE                                                     
## Copyright 1999-2003 Soholaunch.com, Inc.  All Rights Reserved.       
##                                                                        
## This script may be used and modified in accordance to the license      
## agreement attached (license.txt) except where expressly noted within      
## commented areas of the code body. This copyright notice and the comments  
## comments above and below must remain intact at all times.  By using this 
## code you agree to indemnify Soholaunch.com, Inc, its coporate agents   
## and affiliates from any liability that might arise from its use.                                                        
##                                                                           
## Selling the code for this program without prior written consent is       
## expressly forbidden and in violation of Domestic and International 
## copyright laws.  		                                           
###############################################################################

error_reporting(0);
session_cache_limiter('none'); 
session_start();
track_vars;

$THIS_DISPLAY = "";
$updated_text = "";

##########################################################################
### Register the session for secure socket if needed
##########################################################################

if (!session_is_registered("CART_KEYID")) {
	SESSION_REGISTER("CART_KEYID");
	SESSION_REGISTER("CART_SKUNO");
	SESSION_REGISTER("CART_CATNO");
	SESSION_REGISTER("CART_PRODNAME");
	SESSION_REGISTER("CART_SUBCAT");
	SESSION_REGISTER("CART_VARNAME");
	SESSION_REGISTER("CART_UNITPRICE");
	SESSION_REGISTER("CART_QTY");
	SESSION_REGISTER("CART_UNITSUBTOTAL");
	SESSION_REGISTER("WIN_FULL_PATH");
}

reset($HTTP_POST_VARS);
while (list($name, $value) = each($HTTP_POST_VARS)) {
	if (eregi("CART_", $name)) {
		$value = htmlspecialchars($value);	// Bugzilla #32 (This line was not here for #13)
		${$name} = $value;	
	} else {
		$value = htmlspecialchars($value);	// Bugzilla #13
		${$name} = $value;
	}
}

##########################################################################
### WE WILL NEED TO KNOW THE DATABASE NAME; UN; PW; ETC TO OPERATE THE  
### REAL-TIME EXECUTION.  THIS IS CONFIGURED IN THE isp.conf FILE      
##########################################################################

include("pgm-cart_config.php");
$dot_com = $this_ip;	// Assign dot_com variable to configured ip address

##########################################################################
### Verify that this is not a hacker attempt to distort cart pricing 
### Bugzilla #11
### Modified further to accomodate Bugzilla #32 && Bugzilla #20 (Dup)
##########################################################################

if ($CART_SKUNO != "" && $CART_UNITPRICE != "") {
	
	$hacker = 0;	// Setup Hacker Flag to Zero 
		
		$skuCheck = split(";", $CART_SKUNO);
		$priceCheck = split(";", $CART_UNITPRICE);
		
		$subtotalCheck = split(";", $CART_UNITSUBTOTAL);
		$qtyCheck = split(";", $CART_QTY);
	
	$UPDATE_PRICING = "";		// Bugzilla #32
	$UPDATE_SUBTOTAL = "";		// Bugzilla #32
	
		$tmp = count($skuCheck);	// How many sku's have been added to cart for checkout?
	
		for ($x=0;$x<=$tmp;$x++) {
		
			if ($skuCheck[$x] != "") {	
				$newSkuTest = mysql_query("SELECT PROD_UNITPRICE FROM cart_products WHERE PROD_SKU = '$skuCheck[$x]'");

				$validateTest = mysql_num_rows($newSkuTest);		// Bugzilla #32
				if ($validateTest < 1) { $hacker = 1; }				// Reflects that given key sku does not exist in database; therefore a hacker has tampered with form data
				
				// Please note; this will also bomb if a given sku is deleted during a checkout
				// process.  The odds of this happening or slim, but do exist.  I would say that
				// it is a good practice to remove sku's from "display" for 48 hours before deleteing
				// them from the data table if this becomes an issue.

			// Set real price for sku from database -- hackers can not change prices
			$dbValue = mysql_fetch_array($newSkuTest);			
			$UPDATE_PRICING .= $dbValue[PROD_UNITPRICE] . ";";
			
			// Update SubTotal Calculation for multiple qty ordered
			$thisQty = $qtyCheck[$x];
			if ($thisQty < 1) { $thisQty = 1; }
			
			$sCalc = $thisQty*$dbValue[PROD_UNITPRICE];
			$UPDATE_SUBTOTAL .= $sCalc . ";";

		} // End if No Val

	} // End Next loop
	
	if ($hacker != 0) {
		echo "<CENTER><H1><FONT COLOR=RED>ILLEGAL PRODUCT ADDITION DETECTED.</FONT></H1>";
		exit;
	} else {		
		$CART_UNITPRICE = $UPDATE_PRICING;		// Re-Create Sku Prices based on latest database values; not form values or hacker attempts (Bugzilla #32)
		$CART_UNITSUBTOTAL = $UPDATE_SUBTOTAL;	// Bugzilla #32 Fix (Subs)
	}
				
} // End If Sku and Unit Price Var Set	

##########################################################################
### READ SHOPPING CART SETUP OPTIONS
##########################################################################

$result = mysql_query("SELECT * FROM cart_options");
$OPTIONS = mysql_fetch_array($result);

$result = mysql_query("SELECT * FROM cart_paypal");
$PAYPAL = mysql_fetch_array($result);

$result = mysql_query("SELECT * FROM cart_shipping_opts");
$SHIPPING_OPTS = mysql_fetch_array($result);

##########################################################################
### INSERT VALIDATE EMAIL FUNCTION
##########################################################################

function email_is_valid ($email) { 
				// Bugzilla #15 resolved
				if (eregi("^[0-9a-z]([-_.]?[0-9a-z])*@[0-9a-z]([-.]?[0-9a-z])*\\.[a-z]{2,4}$", $email, $check)) { 
					return TRUE; 
				}				
				return FALSE; 
}	// END VALIDATE EMAIL FUNCTION

##########################################################################

//
//      ####  
//        ## 
//        ##
//        ##
//        ## 
//        ##
//        ##     
//     #######
//

##########################################################################
### DETERMINE IF "REMEMBER ME" IS TURNED ON; IF SO ALLOW CUSTOMER LOGIN
### NOW OR ALLOW "NEW" USER REGISTRATION.  IF NOT TURNED ON, GO DIRECTLY
### TO NEW USER REGISTRATION.
##########################################################################

if (eregi("Y", $OPTIONS[DISPLAY_REMEMBERME] ) && !eregi("Y", $customer_active) && $REPEATCUSTOMER != "YES") {		// Remember me is ON

		// ----------------------------------------------------------
		// DISPLAY CHECKOUT ROUTINE STEPS FOR REFERENCE BY CUSTOMER
		// ----------------------------------------------------------

		$THIS_DISPLAY .= "<TABLE BORDER=0 CELLPADDING=4 CELLSPACING=0 WIDTH=100% CLASS=text STYLE='border: 1px inset black;'>\n";
		$THIS_DISPLAY .= "<TR>\n";
 		$THIS_DISPLAY .= "<TD ALIGN=LEFT VALIGN=TOP CLASS=smtext BGCOLOR=WHITE><FONT COLOR=BLACK>\n";
		$THIS_DISPLAY .= "<B>Step 1:<BR>Customer Sign-in</B>\n";
		$THIS_DISPLAY .= "</TD>\n";

		$THIS_DISPLAY .= "<TD ALIGN=LEFT VALIGN=TOP CLASS=smtext BGCOLOR=WHITE><FONT COLOR=#CCCCCC>\n";
		$THIS_DISPLAY .= "Step 2:<BR>Billing & Shipping<BR>Information\n";
		$THIS_DISPLAY .= "</TD>\n";

		$THIS_DISPLAY .= "<TD ALIGN=LEFT VALIGN=TOP CLASS=smtext BGCOLOR=WHITE><FONT COLOR=#CCCCCC>\n";
		$THIS_DISPLAY .= "Step 3:<BR>Shipping Options\n";
		$THIS_DISPLAY .= "</TD>\n";

		$THIS_DISPLAY .= "<TD ALIGN=LEFT VALIGN=TOP CLASS=smtext BGCOLOR=WHITE><FONT COLOR=#CCCCCC>\n";
		$THIS_DISPLAY .= "Step 4:<BR>Verify Order<BR>Details\n";
		$THIS_DISPLAY .= "</TD>\n";

		$THIS_DISPLAY .= "<TD ALIGN=LEFT VALIGN=TOP CLASS=smtext BGCOLOR=WHITE><FONT COLOR=#CCCCCC>\n";
		$THIS_DISPLAY .= "Step 5:<BR>Make Payment\n";
		$THIS_DISPLAY .= "</TD>\n";

		$THIS_DISPLAY .= "<TD ALIGN=LEFT VALIGN=TOP CLASS=smtext BGCOLOR=WHITE><FONT COLOR=#CCCCCC>\n";
		$THIS_DISPLAY .= "Step 6:<BR>Print Final<BR>Invoice\n";
		$THIS_DISPLAY .= "</TD>\n";

		$THIS_DISPLAY .= "</TR></TABLE><BR>\n";

		// ----------------------------------------------------------

		$THIS_DISPLAY .= "<TABLE BORDER=0 CELLPADDING=4 CELLSPACING=0 WIDTH=100% CLASS=text STYLE='border: 1px inset black;'>\n";
		$THIS_DISPLAY .= "<TR>\n";
		$THIS_DISPLAY .= "<TD ALIGN=LEFT VALIGN=TOP CLASS=text BGCOLOR=$OPTIONS[DISPLAY_HEADERBG] WIDTH=95%><FONT COLOR=$OPTIONS[DISPLAY_HEADERTXT]>\n";
		$THIS_DISPLAY .= "<B>STEP 1: CUSTOMER SIGN-IN</B><BR>Select an option below so that we can recognize you.\n";
		$THIS_DISPLAY .= "</TD></TR></TABLE><BR>\n";

		// ----------------------------------------------------------
		// SHOW LINKS TO PRIVACY AND OTHER POLICIES HERE
		// ----------------------------------------------------------

		$THIS_DISPLAY .= "<P class=text><A HREF=\"start.php?policy=shipping&customernumber=$customernumber&=SID\">Shipping Information</a>";
		$THIS_DISPLAY .= "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\n";
		$THIS_DISPLAY .= "<A HREF=\"start.php?policy=returns&customernumber=$customernumber&=SID\">Returns & Exchanges</a>";
		$THIS_DISPLAY .= "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\n";
		$THIS_DISPLAY .= "<A HREF=\"start.php?policy=privacy&customernumber=$customernumber&=SID\">Privacy Policy</a>";
		$THIS_DISPLAY .= "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\n";
		$THIS_DISPLAY .= "<A HREF=\"start.php?policy=other&customernumber=$customernumber&=SID\">Other Policies</a></P>";

		// ----------------------------------------------------------

		$THIS_DISPLAY .= "<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH=100% CLASS=text>\n";
		$THIS_DISPLAY .= "<TR>\n";
		$THIS_DISPLAY .= "<TD ALIGN=LEFT VALIGN=TOP CLASS=text WIDTH=50%>\n";

			$THIS_DISPLAY .= "<TABLE BORDER=0 CELLPADDING=4 CELLSPACING=0 WIDTH=95% HEIGHT=175 CLASS=text STYLE='border: 1px inset black;'>\n";
			$THIS_DISPLAY .= "<TR>\n";
			$THIS_DISPLAY .= "<TD ALIGN=LEFT VALIGN=TOP CLASS=text BGCOLOR=$OPTIONS[DISPLAY_HEADERBG] WIDTH=95%><FONT COLOR=$OPTIONS[DISPLAY_HEADERTXT]>\n";
			$THIS_DISPLAY .= "<B>New Customer\n";
			$THIS_DISPLAY .= "</TD></TR>\n";
			$THIS_DISPLAY .= "<TR><TD ALIGN=LEFT VALIGN=TOP BGCOLOR=WHITE CLASS=text>\n";
			$THIS_DISPLAY .= "If you are a first time buyer select this option.  You will have the opportunity to register and become a prefered customer.\n";
			$THIS_DISPLAY .= "<FORM METHOD=POST ACTION=\"pgm-checkout.php\"><INPUT TYPE=HIDDEN NAME=customernumber VALUE=\"$customernumber\"><INPUT TYPE=HIDDEN NAME=\"customer_active\" VALUE=\"Y\"><DIV ALIGN=CENTER><INPUT TYPE=SUBMIT VALUE=\" New Customer \" CLASS=text STYLE='CURSOR: HAND;'></DIV><BR>&nbsp;</FORM>\n";
			$THIS_DISPLAY .= "</td></tr></TABLE>\n";

		$THIS_DISPLAY .= "</TD>\n";
		$THIS_DISPLAY .= "<TD ALIGN=RIGHT VALIGN=TOP CLASS=text WIDTH=50%>\n";

			$THIS_DISPLAY .= "<TABLE BORDER=0 CELLPADDING=4 CELLSPACING=0 WIDTH=95% HEIGHT=175 CLASS=text STYLE='border: 1px inset black;'>\n";
			$THIS_DISPLAY .= "<TR>\n";
			$THIS_DISPLAY .= "<TD ALIGN=LEFT VALIGN=TOP CLASS=text BGCOLOR=$OPTIONS[DISPLAY_HEADERBG] WIDTH=95%><FONT COLOR=$OPTIONS[DISPLAY_HEADERTXT]>\n";
			$THIS_DISPLAY .= "<B>Existing Customers, Login Now:\n";
			$THIS_DISPLAY .= "</TD></TR>\n";
			$THIS_DISPLAY .= "<TR><TD ALIGN=CENTER VALIGN=TOP BGCOLOR=WHITE CLASS=text><FORM METHOD=POST ACTION=\"pgm-rememberme.php\">\n";
			$THIS_DISPLAY .= "Username: <INPUT TYPE=TEXT SIZE=25 NAME=\"SCUN\" CLASS=text STYLE='WIDTH: 200px;'>&nbsp;<BR>Password: <INPUT TYPE=PASSWORD NAME=\"SCPW\" SIZE=25 CLASS=text STYLE='WIDTH: 200px;'>\n";
			$THIS_DISPLAY .= "<BR><BR><INPUT TYPE=HIDDEN NAME=customernumber VALUE=\"$customernumber\"><DIV ALIGN=CENTER><INPUT TYPE=SUBMIT VALUE=\" Login \" CLASS=text STYLE='CURSOR: HAND;'></DIV>\n";

			if ($SCUN != "" || $SCPW != "" || $rem_err == 1) { $THIS_DISPLAY .= "<BR><FONT COLOR=RED>Unrecognized Customer. Try Again.</FONT>"; }

			$THIS_DISPLAY .= "<BR>Forget your Password? <A HREF=\"pgm-get_password.php?customernumber=$customernumber&ACTION=FIND&=SID\">Click Here</A>.";
			$THIS_DISPLAY .= "</FORM>\n";
			$THIS_DISPLAY .= "</td></tr></TABLE>\n";

		$THIS_DISPLAY .= "</TD></TR></TABLE><P class=text>\n";

		// ----------------------------------------------------------
		// Give user the option to shop more if they prefer; don't
		// stop a client from buying more!
		// ----------------------------------------------------------

		$THIS_DISPLAY .= "<DIV ALIGN=CENTER><A HREF=\"start.php?browse=1&customernumber=$customernumber&=SID\"><IMG SRC=\"continue_button.gif\" WIDTH=161 HEIGHT=25 ALIGN=ABSMIDDLE BORDER=0></A>\n</DIV>\n";



} else {

	$customer_active = "Y";

} // End Remember Me Routine

//
//     ####### 
//    ##     ##
//          ###
//         ###
//        ###
//      ###
//    ###
//    #########
//

##########################################################################
### CUSTOMER STEP 2: GET BILLING AND SHIPPING INFORMATION
##########################################################################

if ($customer_active == "Y" && $STEP == "") {

		// ----------------------------------------------------------
		// DISPLAY CHECKOUT ROUTINE STEPS FOR REFERENCE BY CUSTOMER
		// ----------------------------------------------------------

		$THIS_DISPLAY .= "<TABLE BORDER=0 CELLPADDING=4 CELLSPACING=0 WIDTH=100% CLASS=text STYLE='border: 1px inset black;'>\n";
		$THIS_DISPLAY .= "<TR>\n";

		$THIS_DISPLAY .= "<TD ALIGN=LEFT VALIGN=TOP CLASS=smtext BGCOLOR=WHITE><FONT COLOR=#CCCCCC>\n";
		$THIS_DISPLAY .= "Step 1:<BR>Customer Sign-in\n";
		$THIS_DISPLAY .= "</TD>\n";

		$THIS_DISPLAY .= "<TD ALIGN=LEFT VALIGN=TOP CLASS=smtext BGCOLOR=WHITE><FONT COLOR=BLACK>\n";
		$THIS_DISPLAY .= "<B>Step 2:<BR>Billing & Shipping<BR>Information</B>\n";
		$THIS_DISPLAY .= "</TD>\n";

		$THIS_DISPLAY .= "<TD ALIGN=LEFT VALIGN=TOP CLASS=smtext BGCOLOR=WHITE><FONT COLOR=#CCCCCC>\n";
		$THIS_DISPLAY .= "Step 3:<BR>Shipping Options\n";
		$THIS_DISPLAY .= "</TD>\n";

		$THIS_DISPLAY .= "<TD ALIGN=LEFT VALIGN=TOP CLASS=smtext BGCOLOR=WHITE><FONT COLOR=#CCCCCC>\n";
		$THIS_DISPLAY .= "Step 4:<BR>Verify Order<BR>Details\n";
		$THIS_DISPLAY .= "</TD>\n";

		$THIS_DISPLAY .= "<TD ALIGN=LEFT VALIGN=TOP CLASS=smtext BGCOLOR=WHITE><FONT COLOR=#CCCCCC>\n";
		$THIS_DISPLAY .= "Step 5:<BR>Make Payment\n";
		$THIS_DISPLAY .= "</TD>\n";

		$THIS_DISPLAY .= "<TD ALIGN=LEFT VALIGN=TOP CLASS=smtext BGCOLOR=WHITE><FONT COLOR=#CCCCCC>\n";
		$THIS_DISPLAY .= "Step 6:<BR>Print Final<BR>Invoice\n";
		$THIS_DISPLAY .= "</TD>\n";

		$THIS_DISPLAY .= "</TR></TABLE><BR>\n";

		// ----------------------------------------------------------

		$THIS_DISPLAY .= "<TABLE BORDER=0 CELLPADDING=4 CELLSPACING=0 WIDTH=100% CLASS=text STYLE='border: 1px inset black;'>\n";
		$THIS_DISPLAY .= "<TR>\n";
		$THIS_DISPLAY .= "<TD ALIGN=LEFT VALIGN=TOP CLASS=text BGCOLOR=$OPTIONS[DISPLAY_HEADERBG] WIDTH=95%><FONT COLOR=$OPTIONS[DISPLAY_HEADERTXT]>\n";
		$THIS_DISPLAY .= "<B>STEP 2: BILLING AND SHIPPING INFORMATION</B><BR>Please fill out all fields. You will have a chance to verify and correct this information if necessary.\n";
		$THIS_DISPLAY .= "</TD></TR></TABLE><BR>\n";


		ob_start(); 
			include("prod_billing_shipping.inc");
			$THIS_DISPLAY .= ob_get_contents(); 
		ob_end_clean(); 


} // End process customer step 2


//
//     ####### 
//    ##     ##
//           ##
//          ###
//        #### 
//          ###
//    ##     ## 
//     #######
//

##########################################################################
### CUSTOMER STEP 3: CALCULATE SHIPPING CHARGES.
### **INCLUDE CUSTOM SHIPPING INCLUDE FOR DISPLAY IF NECESSARY
##########################################################################

if ($STEP == "3") {

	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	// First and foremost, register all customer data in session for easy edit
	// functions later. DO NOT WRITE THIS CUSTOMER TO CUSTOMER OR INVOICE TABLE
	// YET -- HE MIGHT LOSE CONNECTION OR OPT OUT OF FULL PURCHASE AFTER
	// SHIPPING CALCULATION.
	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	if (isset($REMEMBERME)) { session_unregister("REMEMBERME"); }

	$tmp_rem = 0;
	reset($HTTP_POST_VARS);
	while (list($name, $value) = each($HTTP_POST_VARS)) {

		$value = htmlspecialchars($value);	// Bugzilla #13
		
		if ($tmp_rem == 1) {
			if (!session_is_registered("$name")) { 
				session_register("$name");
			}
			$value = stripslashes($value);
			$value = strtolower($value);
			if ($name != "BPASSWORD" && $name != "BVERIFYPW" && $name != "BEMAILADDRESS") {
				$value = ucwords($value);
			}
			${$name} = $value;
		}
		if ($name == "STEP" && $value == "3") { $tmp_rem = 1; }
	}

	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	// VERIFY REMEMBER ME PASSWORD, EMAIL ADDRESS and US STATE AFTER SESSION REGISTRATION
	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	$pwerror = 0;
	$email_err = 0;
	$rm_err = 0;
	$st_err = 0;

	if ($SCOUNTRY == "United States") {		// Verify Shipping State -- That is where we charge tax

		// Open valid us states file
		// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~`

		$filename = "us_states.dat";
		$file = fopen("$filename", "r");
			$states_array = fread($file,filesize($filename));
		fclose($file);
		$state = split("\n", $states_array);
		$num_states = count($state);

		$test = strtoupper($SSTATE);

		$st_err = 1;

		for ($x=0;$x<=$num_states;$x++) {
			$tmp = " - $state[$x] ";
			if (eregi(" - $test ", $tmp)) { $st_err = 0; $SSTATE = $state[$x]; }	
		}

	} // End verify us state routine (SHIPPING)

	if ($BCOUNTRY == "United States") {		// Don't Error -- but see if we can modify billing state for display

		// Open valid us states file
		// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~`

		$filename = "us_states.dat";
		$file = fopen("$filename", "r");
			$states_array = fread($file,filesize($filename));
		fclose($file);
		$state = split("\n", $states_array);
		$num_states = count($state);

		$test = strtoupper($BSTATE);

		for ($x=0;$x<=$num_states;$x++) {
			$tmp = " - $state[$x] ";
			if (eregi(" - $test ", $tmp)) { $BSTATE = $state[$x]; }	
		}

	} // End verify us state routine (BILLING)
	
	// ----------------------------------------------------------------------------
	// Let's hard code validate all required user data submitted (MOD BUILD 10)
	// ----------------------------------------------------------------------------	
	$err_read = "";

	// Check Billing Data
	// ----------------------------------------------------

	if ($BFIRSTNAME == "") {
		$err_read = $err_read."A;";
	}
	if ($BLASTNAME == "") {
		$err_read = $err_read."B;";
	}
	if (strlen($BADDRESS1) < 5) {
		$err_read = $err_read."C;";
	}
	if (strlen($BCITY) < 3) {
		$err_read = $err_read."D;";
	}
	
	// Remove State Check from Billing Address; Some International
	// Countries do not have a state; ie: Bermuda
	
	if ($SCOUNTRY == "United States") {			// Only Check Phone Number & Zip if US order

		if (strlen($BZIPCODE) < 5) {
			$err_read = $err_read."F;";
		}
		if (strlen($BPHONE_AREACODE) != 3) {
			$err_read = $err_read."G;";
		}
		if (strlen($BPHONE_PREFIX) != 3) {
			$err_read = $err_read."H;";
		}
		if (strlen($BPHONE_SUFFIX) != 4) {
			$err_read = $err_read."I;";
		}

	}

	// Now Check Shipping Data
	// ----------------------------------------------------

	if ($SFIRSTNAME == "") {
		$err_read = $err_read."J;";
	}
	if ($SLASTNAME == "") {
		$err_read = $err_read."K;";
	}
	if (strlen($SADDRESS1) < 5) {
		$err_read = $err_read."L;";
	}
	if (strlen($SCITY) < 3) {
		$err_read = $err_read."M;";
	}

	// We already have a state check routine above for this

	if ($SCOUNTRY == "United States") {			// Only check Zip Code and Phone is US ORDER

		if (strlen($SZIPCODE) < 5) {
			$err_read = $err_read."O;";
		}
		if (strlen($SPHONE_AREACODE) != 3) {
			$err_read = $err_read."P;";
		}
		if (strlen($SPHONE_PREFIX) != 3) {
			$err_read = $err_read."Q;";
		}
		if (strlen($SPHONE_SUFFIX) != 4) {
			$err_read = $err_read."R;";
		}

	}

	// ---------------------------------------------------------------------------------
	// Redirect on Error OR let pass thru for shipping calculation and order verify
	// ---------------------------------------------------------------------------------		

	if ($BPASSWORD != $BVERIFYPW && $REMEMBERME == "On") { $pwerror = 1; }
	
	if (!eregi("WIN", $WINDIR)) {	// Only Validate Email on Linux Machines. GETMX() does not work with WIN32 PHP
		if (!email_is_valid("$BEMAILADDRESS")) { $email_err = 1; }
	}
	
	if ($REMEMBERME == "On" && $BPASSWORD == "" && $BVERIFYPW == "") { $rm_err = 1; }

	if ($pwerror != 0 || $email_err != 0 || $rm_err != 0 || $st_err != 0 || $err_read != "") {
		header("Location: pgm-checkout.php?EDIT_INFO=$EDIT_INFO&err_read=$err_read&st_err=$st_err&rm_err=$rm_err&pwerror=$pwerror&email_err=$email_err&customernumber=$customernumber&STEP=&customer_active=Y&=SID");
		exit;
	}

	// -----------------------------------------------------------------------
	// FREE "SHIPPING_TOTAL" VAR FOR NEW CALCULATIONS
	// -----------------------------------------------------------------------

	$SHIPPING_TOTAL = "0.00";

	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	// CALCULATE CUSTOM INCLUDE SHIP METHOD - THIS INCLUDE MAY WAIT FOR USER
	// INPUT.  THAT'S JUST FINE, SIMPLY HAVE IT RESUBMIT TO THIS SCRIPT WITH
	// A HIDDEN POST VAR IDENTIFING STEP="3" SO THAT IT COMES BACK HERE.
	// THE SCRIPT SHOULD IDENTIFY IF USER INPUT HAS BEEN VALIDATED AND THEN
	// PROCEED, ETC.  
	//
	// DEVNOTE: NO MATTER WHAT THE INCLUDE, WE ARE ASSUMING THAT AFTER THIS
	// FUNCTION EXECUTES, WE RETURN "$SHIPPING_TOTAL" TO THE MAIN SYSTEM.
	// WE WILL REDIRECT TO NEXT STEP AUTOMATICALLY IF "$THIS_DISPLAY" VAR
	// IS EMPTY.  THE ONLY TIME IT WILL NOT BE EMPTY IS WHEN YOU BUILD YOUR
	// INCLUDE TO DISPLAY SOMETHING IN ORDER TO GET CUSTOMER INPUT.
	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	if ($SHIPPING_OPTS[SHIP_METHOD] == "Custom") {

		$this_file = chop($SHIPPING_OPTS[INC_FILENAME]);
		$this_file = "../media/$this_file";

		ob_start(); 
			include("$this_file");
			$THIS_DISPLAY .= ob_get_contents(); 
		ob_end_clean(); 

	}

	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	// CALCULATE STANDARD SHIPPING CHARGES.  NO NEED TO PAUSE HERE.
	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	if ($SHIPPING_OPTS[SHIP_METHOD] == "Standard") {

		$tmp_prikey = split(";", $CART_KEYID);		// Place current shopping cart data PRIKEYs into array
		$tmp_cnt = count($tmp_prikey);				// How many line items are in cart?
		$tmp_qty = split(";", $CART_QTY);			// What is the qty ordered for each sku

		// $tmp_cnt = $tmp_cnt - 2;					// Take 2 off of line item count because of extra ; divisions during add routine

		for ($sc=0;$sc<=$tmp_cnt;$sc++) {

			$ship_price = "";					// Reset match calc vars.  Even though they are temporary
			$new_add = "";						// anything can happen to the math in a loop like this.

			// Pull first line item's "SHIP PRICE (A)" value from products table
			// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

			$result = mysql_query("SELECT PROD_SHIPA FROM cart_products WHERE PRIKEY = '$tmp_prikey[$sc]'");
			$TVAL = mysql_fetch_array($result);

			$ship_price = $TVAL[PROD_SHIPA];

			// Multiply Individual shipping price by current sku qty
			// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

			$new_add = $ship_price*$tmp_qty[$sc];

			$SHIPPING_TOTAL = $SHIPPING_TOTAL + $new_add;	// Add calculation to shipping total

		} // End $sc Loop

	} // End Standard Shipping Calc

	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	// CALCULATE SUB-TOTAL SHIPPING CHARGES.  NO NEED TO PAUSE HERE.
	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	if ($SHIPPING_OPTS[SHIP_METHOD] == "SubTotal") {

		$cartsubtotal = "0.00";								// Clear temp var to begin new calc 
		
		// Placed next line on line of its own (Bugzilla #8 Fixed)
		$tmp_subtotals = split(";", $CART_UNITSUBTOTAL);			// Place current line item sub totals in array


		$tmp_cnt = count($tmp_subtotals);						// How many line items are in cart?
		
		for ($sc=0;$sc<=$tmp_cnt;$sc++) {
			$cartsubtotal = $cartsubtotal + $tmp_subtotals[$sc];		// Build temp subtotal number
		}

		for ($st=1;$st<=8;$st++) {

			$tmp = "ST_GTHAN" . $st;
			$one = $SHIPPING_OPTS[$tmp];

			$tmp = "ST_LTHAN" . $st;
			$two = $SHIPPING_OPTS[$tmp];

			$tmp = "ST_SHIP" . $st;
			$three = $SHIPPING_OPTS[$tmp];
	
			if ($one != "" && $two != "") { 
				if ($cartsubtotal > $one && $cartsubtotal < $two) { $SHIPPING_TOTAL = $three; }
			}
			if ($one != "" && $two == "") { 
				if ($cartsubtotal > $one) { $SHIPPING_TOTAL = $three; }
			}

		} // End for $st Loop

	} // End SubTotal Ship Method

	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	// REGISTER "$SHIPPING_TOTAL" VARIABLE IN SESSION -- SHIPPING CALCULATED!
	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	$SHIPPING_TOTAL = sprintf ("%01.2f", $SHIPPING_TOTAL);			// Make sure SHIPPING_TOTAL is formated for proper display

	if (!session_is_registered("SHIPPING_TOTAL")) { 
		session_register("SHIPPING_TOTAL");
	}

	$SHIPPING_TOTAL = $SHIPPING_TOTAL;	// Just in case PHP doesn't propogate var value until after var registration

	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	// IF "$THIS_DISPLAY" var is empty, redirect to next step, we have the
	// shipping total now... else pass through and display any data from 
	// include script that needs customer input.
	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	if ($THIS_DISPLAY == "") {
		$STEP = "4";
	}

} // End Step 3


//
//    ##      ## 
//    ##      ##
//    ##      ##
//    ##########
//            ## 
//            ##
//            ## 
//            ##
//

##########################################################################
### CUSTOMER STEP 4: VERIFY ORDER INVOICE AND SELECT PAYMENT METHOD
##########################################################################

if ($STEP == "4") {

	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	// Build INVOICE HTML -- This will be the same thing used for the
	// final customer receipt and display as well
	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	ob_start(); 
	include("prod_cust_invoice.inc");
		$INVOICE = ob_get_contents(); 
	ob_end_clean(); 

	// ----------------------------------------------------------
	// DISPLAY CHECKOUT ROUTINE STEPS FOR REFERENCE BY CUSTOMER
	// ----------------------------------------------------------

	$THIS_DISPLAY .= "<TABLE BORDER=0 CELLPADDING=4 CELLSPACING=0 WIDTH=100% CLASS=text STYLE='border: 1px inset black;'>\n";
	$THIS_DISPLAY .= "<TR>\n";

	$THIS_DISPLAY .= "<TD ALIGN=LEFT VALIGN=TOP CLASS=smtext BGCOLOR=WHITE><FONT COLOR=#CCCCCC>\n";
	$THIS_DISPLAY .= "Step 1:<BR>Customer Sign-in\n";
	$THIS_DISPLAY .= "</TD>\n";

	$THIS_DISPLAY .= "<TD ALIGN=LEFT VALIGN=TOP CLASS=smtext BGCOLOR=WHITE><FONT COLOR=#CCCCCC>\n";
	$THIS_DISPLAY .= "Step 2:<BR>Billing & Shipping<BR>Information</B>\n";
	$THIS_DISPLAY .= "</TD>\n";

	$THIS_DISPLAY .= "<TD ALIGN=LEFT VALIGN=TOP CLASS=smtext BGCOLOR=WHITE><FONT COLOR=#CCCCCC>\n";
	$THIS_DISPLAY .= "Step 3:<BR>Shipping Options\n";
	$THIS_DISPLAY .= "</TD>\n";

	$THIS_DISPLAY .= "<TD ALIGN=LEFT VALIGN=TOP CLASS=smtext BGCOLOR=WHITE><FONT COLOR=BLACK>\n";
	$THIS_DISPLAY .= "<B>Step 4:<BR>Verify Order<BR>Details\n";
	$THIS_DISPLAY .= "</TD>\n";

	$THIS_DISPLAY .= "<TD ALIGN=LEFT VALIGN=TOP CLASS=smtext BGCOLOR=WHITE><FONT COLOR=#CCCCCC>\n";
	$THIS_DISPLAY .= "Step 5:<BR>Make Payment\n";
	$THIS_DISPLAY .= "</TD>\n";

	$THIS_DISPLAY .= "<TD ALIGN=LEFT VALIGN=TOP CLASS=smtext BGCOLOR=WHITE><FONT COLOR=#CCCCCC>\n";
	$THIS_DISPLAY .= "Step 6:<BR>Print Final<BR>Invoice\n";
	$THIS_DISPLAY .= "</TD>\n";

	$THIS_DISPLAY .= "</TR></TABLE><BR>\n";

	// ----------------------------------------------------------

	$THIS_DISPLAY .= "<TABLE BORDER=0 CELLPADDING=4 CELLSPACING=0 WIDTH=100% CLASS=text STYLE='border: 1px inset black;'>\n";
	$THIS_DISPLAY .= "<TR>\n";
	$THIS_DISPLAY .= "<TD ALIGN=LEFT VALIGN=TOP CLASS=text BGCOLOR=$OPTIONS[DISPLAY_HEADERBG] WIDTH=95%><FONT COLOR=$OPTIONS[DISPLAY_HEADERTXT]>\n";
	$THIS_DISPLAY .= "<B>STEP 4: VERIFY ORDER DETAILS</B><BR>Please double check that all information is correct.\n";
	$THIS_DISPLAY .= "</TD></TR></TABLE><BR>\n";

	// ---------------------------------------------------
	// Register INVOICE with our session for databasing
	// ---------------------------------------------------

	if (!session_is_registered("INVOICE")) { 
		session_register("INVOICE");
	}

	$INVOICE = $INVOICE;

	// ------------------------------------------------------------------------------
	// Place the edit links into the INVOICE html -- Remember, we are going to use
	// this for the email and final reciept so we don't won't edit links showing up
	// at that stage
	// ------------------------------------------------------------------------------

	$THIS_INVOICE = eregi_replace("<!-- EDIT -->", "<FONT SIZE=1 FACE=ARIAL>[ <a href=\"pgm-checkout.php?customernumber=$customernumber&EDIT_INFO=ON&customer_active=Y&=SID\">EDIT</a> ]</font>", $INVOICE);
	$THIS_DISPLAY .= $THIS_INVOICE;

	// ------------------------------------------------------------------------------
	// Allow user to select payment method
	// ------------------------------------------------------------------------------

	$THIS_DISPLAY .= "<BR><TABLE BORDER=0 CELLPADDING=4 CELLSPACING=0 WIDTH=100% CLASS=text STYLE='border: 1px inset black;'>\n";
	$THIS_DISPLAY .= "<TR>\n";
	$THIS_DISPLAY .= "<TD ALIGN=LEFT VALIGN=TOP CLASS=text BGCOLOR=$OPTIONS[DISPLAY_HEADERBG]><FONT COLOR=$OPTIONS[DISPLAY_HEADERTXT]>\n";
	$THIS_DISPLAY .= "<B>SELECT YOUR METHOD OF PAYMENT</B><BR>Choose your method of payment by clicking on the desired button.\n";

	// ----------------------------------------------------------------------------------
	// If this merchant is using the built-in VeriSign(TM) Payflow system, display logo
	// ----------------------------------------------------------------------------------

	if ($OPTIONS[PAYMENT_VLOGINID] != "" && $OPTIONS[PAYMENT_VPARTNERID] != "" && eregi("ONLINE", $OPTIONS[PAYMENT_PROCESSING_TYPE])) {
		$THIS_DISPLAY .= "</TD><TD ALIGN=RIGHT VALIGN=MIDDLE CLASS=text BGCOLOR=$OPTIONS[DISPLAY_HEADERBG]><A HREF=\"http://www.verisign.com\" target=\"_blank\"><IMG SRC='verisign.gif' WIDTH=86 HEIGHT=36 BORDER=0 HSPACE=1 VSPACE=1></A>\n";
	}// End VeriSign(tm) Test

	if (strlen($PAYPAL[PAYPAL_EMAIL]) > 3) {
		$THIS_DISPLAY .= "</TD><TD ALIGN=RIGHT VALIGN=MIDDLE CLASS=text BGCOLOR=$OPTIONS[DISPLAY_HEADERBG]><A HREF=\"http://www.paypal.com\" target=\"_blank\"><IMG SRC='paypal_logo.gif' BORDER=0 HSPACE=1 VSPACE=1></A>\n";
	}// End PayPal(tm) Test

	$THIS_DISPLAY .= "</TD></TR></TABLE>\n";

	// Logic:

	$THIS_DISPLAY .= "<BR><TABLE BORDER=0 CELLPADDING=4 CELLSPACING=0 WIDTH=75% CLASS=text>\n";
	$THIS_DISPLAY .= "<TR>\n";

	// ----------------------------------------------------------------------------	
	// Is this cart setup to take credit card payments or check/money order only?
	// ----------------------------------------------------------------------------

	if (!eregi("Y", $OPTIONS[PAYMENT_CHECK_ONLY])) {

			$NOTICE_DATA = "";

			if (strlen($PAYPAL[PAYPAL_EMAIL]) > 4) {

				$THIS_DISPLAY .= "<TD ALIGN=CENTER VALIGN=MIDDLE CLASS=text>\n";
				$THIS_DISPLAY .= "<FORM METHOD=POST ACTION=\"pgm-payment_gateway.php\">\n";
				$THIS_DISPLAY .= "<INPUT TYPE=HIDDEN NAME=\"customernumber\" VALUE=\"$customernumber\">\n";
				$THIS_DISPLAY .= "<INPUT TYPE=HIDDEN NAME=\"PAY_TYPE\" VALUE=\"CREDITCARD\">\n";
				$THIS_DISPLAY .= "<INPUT TYPE=SUBMIT VALUE=\" Credit Card/PayPal \" CLASS=FormLt1 STYLE='WIDTH: 150px;'></FORM>\n";
				$THIS_DISPLAY .= "</TD>\n";

			} else {

				$THIS_DISPLAY .= "<TD ALIGN=CENTER VALIGN=MIDDLE CLASS=text>\n";
				$THIS_DISPLAY .= "<FORM METHOD=POST ACTION=\"pgm-payment_gateway.php\">\n";
				$THIS_DISPLAY .= "<INPUT TYPE=HIDDEN NAME=\"customernumber\" VALUE=\"$customernumber\">\n";
				$THIS_DISPLAY .= "<INPUT TYPE=HIDDEN NAME=\"PAY_TYPE\" VALUE=\"CREDITCARD\">\n";
				$THIS_DISPLAY .= "<INPUT TYPE=SUBMIT VALUE=\" Credit/Debit Card \" CLASS=FormLt1 STYLE='WIDTH: 150px;'></FORM>\n";
				$THIS_DISPLAY .= "</TD>\n";

			}

	} else {

			// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			// DEVNOTE:
			// If this is check/money order only, give notice about that fact.
			// Realisticly you could take this out if you wish, but people sometimes
			// wonder if they "missed" the chance to select "Credit Card" checkout
			// somewhere in the checkout process.
			// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

			$NOTICE_DATA = "Currently we are only accepting Check or Money Order payments.<BR><BR>";
	}

	// ----------------------------------------------------------------------------
	// Allow Check/Money Order Payment no matter what
	// ----------------------------------------------------------------------------	

	$THIS_DISPLAY .= "<TD ALIGN=CENTER VALIGN=MIDDLE CLASS=text>\n";
	$THIS_DISPLAY .= "<FORM METHOD=POST ACTION=\"pgm-payment_gateway.php\">\n";
	$THIS_DISPLAY .= "<INPUT TYPE=HIDDEN NAME=\"customernumber\" VALUE=\"$customernumber\">\n";
	$THIS_DISPLAY .= "<INPUT TYPE=HIDDEN NAME=\"PAY_TYPE\" VALUE=\"CHECK\">$NOTICE_DATA\n";
	$THIS_DISPLAY .= "<INPUT TYPE=SUBMIT VALUE=\" Check or Money Order \" CLASS=FormLt1 STYLE='WIDTH: 150px;'></FORM>\n";
	$THIS_DISPLAY .= "</TD>\n";

	// ----------------------------------------------------------------------------

	$THIS_DISPLAY .= "</TR></TABLE>\n\n";

	// ------------------------------------------------------------------------------
	// If credit card orders are "on", let's show all the credit cards this merchant
	// accepts (again) in case their is any doubt in customers mind.
	// ------------------------------------------------------------------------------

	if (!eregi("Y", $OPTIONS[PAYMENT_CHECK_ONLY])) {

		$CARDNAME = split(";", $OPTIONS[PAYMENT_CREDIT_CARDS]);	// Split Field into individual card names
		$NUMCARDS = count($CARDNAME);						// How many cards are accepted?
		$NUMCARDS--;								// Subtract 1 from total because we start at zero

		$THIS_DISPLAY .= "<TABLE BORDER=0 CELLPADDING=4 CELLSPACING=0 WIDTH=100% CLASS=text>\n";
		$THIS_DISPLAY .= "<TR>\n";
		$THIS_DISPLAY .= "<TD ALIGN=CENTER VALIGN=MIDDLE CLASS=text>We currently accept the following credit cards:<BR>\n";

		for ($z=0;$z<=$NUMCARDS;$z++) {
	
			if ($CARDNAME[$z] != "") {					// Make sure we don't count blanks

				$THISCARD = strtolower($CARDNAME[$z]);		// Make cardname lower case (match filename)
	
				$THIS_DISPLAY .= "<IMG SRC='".$THISCARD.".gif' HSPACE=25 VSPACE=10 BORDER=0 ALIGN=ABSMIDDLE>";

			} // End Blank If

		} // End For Loop

		$THIS_DISPLAY .= "</TD></TR></TABLE>\n\n";

	} // End Credit "on" check



	// ------------------------------------------------------------------------------

} // End Step 4

//	#######   ###    ##    ####
// 	##        ####   ##    ## ##
//	##        ## ##  ##    ##  ##
// 	####      ##  ## ##    ##   ##
// 	##        ##   ####    ##  ##
// 	##        ##    ###    ## ##
// 	#######   ##     ##    ####

##########################################################################
### BUILD OVERALL TABLE TO PLACE FINAL OUTPUT WITHIN
##########################################################################

$FINAL_DISPLAY = "<TABLE BORDER=0 CELLPADDING=2 CELLSPACING=0 WIDTH=612 ALIGN=CENTER>\n";
$FINAL_DISPLAY .= "<TR>\n";
$FINAL_DISPLAY .= "<TD ALIGN=CENTER VALIGN=TOP>\n\n$THIS_DISPLAY\n\n</TD>\n";
$FINAL_DISPLAY .= "</TR>\n\n";

// ----------------------------------------------------------------------------------
// If a business address has been supplied, display at the footer of each shopping
// cart page.  This can be removed if you wish, but studies have shown it instills
// trust among consumers that wish to buy from this web site
// ----------------------------------------------------------------------------------

if ($OPTIONS[BIZ_ADDRESS_1] != "" && $OPTIONS[BIZ_POSTALCODE] != "") {

	$FINAL_DISPLAY .= "<TR><TD ALIGN=CENTER VALIGN=MIDDLE CLASS=smtext>\n";
	$FINAL_DISPLAY .= "<HR WIDTH=100% STYLE='height: 1px; color: $OPTIONS[DISPLAY_HEADERBG];'>\nMailing Address: $OPTIONS[BIZ_ADDRESS_1], ";

		if ($OPTIONS[BIZ_ADDRESS2] != "") {
			$FINAL_DISPLAY .= "$OPTIONS[BIZ_ADDRESS_2], ";
		}

	$FINAL_DISPLAY .= "$OPTIONS[BIZ_CITY], $OPTIONS[BIZ_STATE], $OPTIONS[BIZ_POSTALCODE]\n<HR WIDTH=100% STYLE='height: 1px; color: $OPTIONS[DISPLAY_HEADERBG];'>";
	$FINAL_DISPLAY .= "</TD></TR>\n\n";

}

// ----------------------------------------------------------------------------------

$FINAL_DISPLAY .= "</TABLE>";

###########################################################################
### THE pgm-realtime_builder.php FILE COMPILES THE TEMPLATE DATA AND PAGE 
### CONTENT DATA TOGETHER AND PUTS IT OUT AS THE $template_header AND 
### $template_footer VARS RESPECTIVELY.  ANY MODIFICATION TO CHANGE THE
### WAY PAGES ARE OUTPUT TO THE SITE VISITOR SHOULD BE MADE WITHIN THE
### realtime_builder.php FILE
###########################################################################

$module_active = "yes";
include ("pgm-template_builder.php");

#######################################################

echo ("$template_header\n");
	$template_footer = eregi_replace("#CONTENT#", $FINAL_DISPLAY, $template_footer);
echo ("$template_footer\n\n");
echo ("\n\n<SCRIPT language=Javascript>\n     window.focus();\n</SCRIPT>\n\n");
exit;

?>