<?php

###############################################################################
## Soholaunch(R) Site Management Tool
## Version 4.5
##      
## Author: 			Mike Johnston [mike.johnston@soholaunch.com]                 
## Homepage:	 	http://www.soholaunch.com
## Bug Reports: 	http://bugzilla.soholaunch.com
## Release Notes:	sohoadmin/build.dat.php
###############################################################################

##############################################################################
## COPYRIGHT NOTICE                                                     
## Copyright 1999-2003 Soholaunch.com, Inc.  All Rights Reserved.       
##                                                                        
## This script may be used and modified in accordance to the license      
## agreement attached (license.txt) except where expressly noted within      
## commented areas of the code body. This copyright notice and the comments  
## comments above and below must remain intact at all times.  By using this 
## code you agree to indemnify Soholaunch.com, Inc, its coporate agents   
## and affiliates from any liability that might arise from its use.                                                        
##                                                                           
## Selling the code for this program without prior written consent is       
## expressly forbidden and in violation of Domestic and International 
## copyright laws.  		                                           
###############################################################################

error_reporting(0);
session_cache_limiter('private'); 
session_start();

include("../includes/login.php");
include("../includes/db_connect.php");

#############################################################################################
### Sterilize Character String Function
#############################################################################################

function sterilize_char ($sterile_var) {

	$sterile_var = stripslashes($sterile_var);
	$sterile_var = eregi_replace(";", ",", $sterile_var);
	// $sterile_var = eregi_replace(" ", "_", $sterile_var);

	$st_l = strlen($sterile_var);
	$st_a = 0;
	$tmp = "";

	while($st_a != $st_l) {
		$temp = substr($sterile_var, $st_a, 1);
		if (eregi("[0-9a-z_]", $temp)) { $tmp .= $temp; }
		$st_a++;
	}

	$sterile_var = $tmp;
	return $sterile_var;

}

#############################################################################################
### For each step we will keep building hidden vars and passing them to the next section
### in case of the end-user presses the back button.  This way it's easier to track the
### "session" without registering the session data. (Less of a memory hog)			       	
#############################################################################################

$HIDDEN_POST = "";
reset($HTTP_POST_VARS);
while (list($name, $value) = each($HTTP_POST_VARS)) {
	$value = stripslashes($value);			// Strip all slashes from data for HTML execution
	if ($name != "STEP_NUM") {
		$HIDDEN_POST .= "<INPUT TYPE=HIDDEN NAME=\"$name\" VALUE=\"$value\">\n";
		${$name} = $value;
	}
}
		
#############################################################################################
### START HTML/JAVASCRIPT CODE			       	
#############################################################################################

$MOD_TITLE = "eNewsletter Campaign Setup Wizard";		// Give Mod Title to System
$TBL_HT = "400";										// For wizard, let's make our table expand height wise
$err_show = "";

#############################################################################################
### Modify Title and Basic Error Trap for Step 1.  Require a Campaign Name
#############################################################################################

$err_show = "";
$err_show1 = "";

if ($CAMPAIGN_NAME != "") {

	$CAMPAIGN_NAME = strtoupper($CAMPAIGN_NAME);
	$MOD_TITLE .= " : '$CAMPAIGN_NAME'";

}

if ($STEP_NUM == 2 && $TABLE_NAME == "") {
	$err_show1 = "<FONT COLOR=RED>*Please select a table name to use for this campaign.</font>";
	$STEP_NUM = "";
}

if ($STEP_NUM == 2 && strlen($CAMPAIGN_NAME) < 3) {
	$err_show = "<FONT COLOR=RED>*Please enter a valid campaign name before continuing.</font>";
	$STEP_NUM = "";
}



#############################################################################################

?>

<HTML>
<HEAD>
<TITLE>eNewsletter Wizard</TITLE>

<META HTTP-EQUIV="Content-Type" content="text/html; charset=iso-8859-1">

<!-- <META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<META HTTP-EQUIV="Expires" CONTENT="-1"> -->

<link rel="stylesheet" href="shared/soholaunch.css">

<script language="JavaScript">
<!--
function SV2_findObj(n, d) { //v3.0
  var p,i,x;  if(!d) d=document; if((p=n.indexOf("?"))>0&&parent.frames.length) {
    d=parent.frames[n.substring(p+1)].document; n=n.substring(0,p);}
  if(!(x=d[n])&&d.all) x=d.all[n]; for (i=0;!x&&i<d.forms.length;i++) x=d.forms[i][n];
  for(i=0;!x&&d.layers&&i<d.layers.length;i++) x=SV2_findObj(n,d.layers[i].document); return x;
}
function SV2_showHideLayers() { //v3.0
  var i,p,v,obj,args=SV2_showHideLayers.arguments;
  for (i=0; i<(args.length-2); i+=3) if ((obj=SV2_findObj(args[i]))!=null) { v=args[i+2];
    if (obj.style) { obj=obj.style; v=(v=='show')?'visible':(v='hide')?'hidden':v; }
    obj.visibility=v; }
}
function SV2_popupMsg(msg) { //v1.0
  alert(msg);
}
function SV2_openBrWindow(theURL,winName,features) { //v2.0
  window.open(theURL,winName,features);
}

function SV2_openBrWindow(theURL,winName,features) { //v2.0
	window.open(theURL,winName,features);
}

SV2_showHideLayers('addCartMenu?header','','hide');
SV2_showHideLayers('blankLayer?header','','hide');
SV2_showHideLayers('linkLayer?header','','hide');
SV2_showHideLayers('newsletterLayer?header','','hide');
SV2_showHideLayers('cartMenu?header','','show');
SV2_showHideLayers('menuLayer?header','','hide');
SV2_showHideLayers('editCartMenu?header','','hide');

function build() {
	LOAD_LAYER.style.visibility = '';
	userOpsLayer.style.visibility = 'hidden';
}

function prev_sel() {

	var template = field_data.TEMPLATE_NAME.value;
	var page_name = field_data.PAGE_NAME.value;
	
	if (template != "" && page_name != "") {
		SV2_openBrWindow("view_setup.php?t="+template+"&p="+page_name+"&=SID", "quickview", "locationbar=no, scrollbars=yes, statusbar=no, width=770, height=450");
	} else {
		alert('You need to select a template and content file in order to preview.');
	}
		
}

function step4() {

	var template = field_data.TEMPLATE_NAME.value;
	var page_name = field_data.PAGE_NAME.value;
	
	if (template != "" && page_name != "") {
		document.field_data.submit();
	} else {
		alert('You need to select a template and content file in order to continue.');
	}
		
}

//-->
</script>

</head>

<body bgcolor=white text=black link=darkblue vlink=darkblue alink=darkblue leftmargin=0 topmargin=0 marginwidth=0 marginheight=0>

<DIV ID="LOAD_LAYER" style="position:absolute; left:0px; top:0px; width:100%; height:98%; z-index:100; border: 2px none #000000; visibility: hidden; overflow: hidden"> 
<table border=0 cellpadding=0 width=100% height=100% bgcolor=WHITE>
    <tr> 
      <td align=center valign=middle class=text> 
		<img src="building.gif" width=200 height=30 border=0><BR>
		<FONT COLOR=#999999>This may take a few seconds...</FONT>
      </td>
    </tr>
  </table>
</DIV>


<DIV ID="userOpsLayer" style="position:absolute; visibility:visible; left:0px; top:0; width:100%; height:100%; z-index:1; visibility: visible; overflow: auto; border: 1px none #000000">

<?

// =================================================================================================
//
//     #####
//        ##
//        ##
//        ##
//        ##
//        ##
//        ##
//    #########
//
// Step One: This is a new "campaign" setup.
// =================================================================================================

if ($STEP_NUM == "") {

	#######################################################
	### FIND ALL WEBSITE DATA TABLES AND CREATE VAR
	### TO POPULATE "CURRENT" TABLES DROP DOWN BOX
	#######################################################
	
	$result = mysql_list_tables("$db_name");
	$i = 0; 
	$CURRENT_TABLES = "     <OPTION VALUE=\"\" STYLE='COLOR: #999999;'>Current Website Data Tables...</OPTION>\n";
	while ($i < mysql_num_rows ($result)) { 
		$tb_names[$i] = mysql_tablename ($result, $i); 
		$i++;
	} 
	
	sort($tb_names[$i]);
	$tmp = $i - 1;
	for ($x=0;$x<=$tmp;$x++) {
		if ($row_color == "white") { $row_color = "#EFEFEF"; } else { $row_color = "white"; }
		$CURRENT_TABLES .= "     <OPTION VALUE=\"$tb_names[$x]\" STYLE='background: $row_color;'>$tb_names[$x]</OPTION>\n";
	}
	
	#######################################################
	
	$THIS_DISPLAY .= "\n\n<!-- ----------------- START STEP 1 ---------------------- -->\n\n";
	
	$THIS_DISPLAY .= "<FORM METHOD=POST ACTION=\"create_campaign.php\">\n";
	$THIS_DISPLAY .= "<INPUT TYPE=HIDDEN NAME=STEP_NUM VALUE=2>\n";
	$THIS_DISPLAY .= $HIDDEN_POST;
	
	$THIS_DISPLAY .= "<TABLE BORDER=0 CELLPADDING=10 CELLSPACING=0 CLASS=text WIDTH=650 BGCOLOR=#EFEFEF STYLE='BORDER: 1px inset black;'>\n";
	$THIS_DISPLAY .= "<TR>\n";
	$THIS_DISPLAY .= "<TD ALIGN=LEFT VALIGN=MIDDLE>\n";
	$THIS_DISPLAY .= "<FONT STYLE='font-size: 11pt;'><TT><U>STEP 1 OF 5</U> : ASSIGN CAMPAIGN NAME</B></TT></FONT>\n";
	$THIS_DISPLAY .= "</TD></TR></TABLE>\n";
	
	$THIS_DISPLAY .= "<TABLE BORDER=0 CELLPADDING=10 CELLSPACING=0 CLASS=text WIDTH=650 STYLE='border: 1px inset black;'>\n";
	$THIS_DISPLAY .= "<TR>\n";
	$THIS_DISPLAY .= "<TD ALIGN=LEFT VALIGN=TOP BGCOLOR=WHITE CLASS=text>\n";
	
		$THIS_DISPLAY .= "A. Give this new campaign a name for easy identification on the campaign manager page: \n";
		$THIS_DISPLAY .= "<BR><INPUT TYPE=TEXT CLASS=text NAME=CAMPAIGN_NAME VALUE=\"$CAMPAIGN_NAME\" STYLE='WIDTH: 200px;'>\n";
		$THIS_DISPLAY .= $err_show;
		
		$THIS_DISPLAY .= "<BR><BR><BR>B. Choose a database table that contains the email addresses for this campaign: \n";
		$THIS_DISPLAY .= "<BR><SELECT NAME=\"TABLE_NAME\" STYLE='FONT-FAMILY: Arial; FONT-SIZE: 8pt; WIDTH: 200px;'>$CURRENT_TABLES</SELECT>\n";
		$THIS_DISPLAY .= $err_show1;
		
		
		$THIS_DISPLAY .= "<BR><BR><BR><BR><DIV ALIGN=RIGHT><INPUT TYPE=SUBMIT VALUE=\" Next >> \" CLASS=FormLt1></DIV>\n\n";
		
	$THIS_DISPLAY .= "</TD></TR></TABLE>\n";
	
	$THIS_DISPLAY .= "</FORM>";

	$THIS_DISPLAY .= "\n\n<!-- ------------------ END STEP 1 ----------------------- -->\n\n";	
	
} // END STEP ONE

// =================================================================================================
//
//   ########
//   ##    ##
//        ##
//       ##
//     ##
//   ##
//   ##    ##
//   ########
//
// =================================================================================================

if ($STEP_NUM == "2") {

	########################################################
	### Put all field names from selected table into var
	### for drop down box placement.  This is how we will 
	### know which field's contain the data we need to
	### build a send.
	########################################################
	
	$result = mysql_query("SELECT * FROM $TABLE_NAME");
	$numberFields = mysql_num_fields($result);
	$numberFields--; 

	$FIELD_NAMES = "     <OPTION VALUE=\"\" STYLE='COLOR: #999999;'>Field Names:</OPTION>\n";
	
	for ($x=0;$x<=$numberFields;$x++) {
		
		$fieldname = mysql_field_name($result, $x);

		if ($row_color == "white") { $row_color = "#EFEFEF"; } else { $row_color = "white"; }

		$FIELD_NAMES .= "     <OPTION VALUE=\"$fieldname\" STYLE='background: $row_color;'>$fieldname</OPTION>\n";

	} // End Num Field Loop

	#######################################################
	
	$THIS_DISPLAY .= "\n\n<!-- ----------------- START STEP 2 ---------------------- -->\n\n";
	
	$THIS_DISPLAY .= "<FORM NAME=field_data METHOD=POST ACTION=\"create_campaign.php\">\n";
	$THIS_DISPLAY .= "<INPUT TYPE=HIDDEN NAME=STEP_NUM VALUE=3>\n";
	$THIS_DISPLAY .= $HIDDEN_POST;
	
	$THIS_DISPLAY .= "<TABLE BORDER=0 CELLPADDING=10 CELLSPACING=0 CLASS=text WIDTH=650 BGCOLOR=#EFEFEF STYLE='BORDER: 1px inset black;'>\n";
	$THIS_DISPLAY .= "<TR>\n";
	$THIS_DISPLAY .= "<TD ALIGN=LEFT VALIGN=MIDDLE>\n";
	$THIS_DISPLAY .= "<FONT STYLE='font-size: 11pt;'><TT><U>STEP 2 OF 5</U> : MATCH REQUIRED FIELD DATA</B></TT></FONT>\n";
	$THIS_DISPLAY .= "</TD></TR></TABLE>\n";
	
	$THIS_DISPLAY .= "<TABLE BORDER=0 CELLPADDING=10 CELLSPACING=0 CLASS=text WIDTH=650 STYLE='border: 1px inset black;'>\n";
	$THIS_DISPLAY .= "<TR>\n";
	$THIS_DISPLAY .= "<TD ALIGN=LEFT VALIGN=TOP BGCOLOR=WHITE CLASS=text>\n";
	
		$THIS_DISPLAY .= "In order to build this campaign using \"$TABLE_NAME\", you will need to tell the system which fields in the table correspond to the data needed by the eNewsletter system when sending this campaign: \n";
		
		$THIS_DISPLAY .= "<BR><BR>A. Field containing <U>FIRST NAME</U> data: \n";
		$THIS_DISPLAY .= "<BR><SELECT NAME=\"USER_FIRST_NAME\" STYLE='FONT-FAMILY: Arial; FONT-SIZE: 8pt; WIDTH: 200px;'>$FIELD_NAMES</SELECT>\n";

		$THIS_DISPLAY .= "<BR><BR>B. Field containing <U>EMAIL ADDRESS</U> data: \n";
		$THIS_DISPLAY .= "<BR><SELECT NAME=\"USER_EMAIL_ADDRESS\" STYLE='FONT-FAMILY: Arial; FONT-SIZE: 8pt; WIDTH: 200px;'>$FIELD_NAMES</SELECT>\n";

		$THIS_DISPLAY .= "<BR><BR>C. Field containing the <U>EMAIL TYPE</U> data: \n";
		$THIS_DISPLAY .= "<BR><SELECT NAME=\"USER_SEND_TYPE\" STYLE='FONT-FAMILY: Arial; FONT-SIZE: 8pt; WIDTH: 200px;'>\n";

			$FIELD_NAMES = eregi_replace("Field Names:", "[ AUTO ]", $FIELD_NAMES);
			
		$THIS_DISPLAY .= "$FIELD_NAMES</SELECT>\n";
		$THIS_DISPLAY .= "<BR><FONT COLOR=#999999>[ If the user has HTML or TEXT preference ]</FONT>\n\n";

		
		$THIS_DISPLAY .= "<BR><BR><BR><BR><DIV ALIGN=RIGHT><INPUT TYPE=SUBMIT VALUE=\" Next >> \" CLASS=FormLt1></DIV>\n\n";
		
	$THIS_DISPLAY .= "</TD></TR></TABLE>\n";
	
	$THIS_DISPLAY .= "</FORM>";

	$THIS_DISPLAY .= "\n\n<!-- ------------------ END STEP 2 ----------------------- -->\n\n";	
	
	#######################################################
	### TRY TO AUTO-MATCH FIELD NAMES IF POSSIBLE
	#######################################################
	
	$THIS_DISPLAY .= "<SCRIPT LANGUAGE=JScript>\n\n";

	$add_jscript = "";
	
	for ($x=0;$x<=$numberFields;$x++) {
		
		$fieldname = mysql_field_name($result, $x);
		if (eregi("email", $fieldname)) { 
			$add_jscript .= "     field_data.USER_EMAIL_ADDRESS.options.value = '$fieldname'; \n";
		}
		if (eregi("first", $fieldname) || eregi("name", $fieldname)) {		
			$add_jscript .= "     field_data.USER_FIRST_NAME.options.value = '$fieldname'; \n";

		}
		if (eregi("type", $fieldname)) {		
			$add_jscript .= "     field_data.USER_SEND_TYPE.options.value = '$fieldname'; \n";
		}

	} // End Num Field Loop
	
	$THIS_DISPLAY .= $add_jscript;
	$THIS_DISPLAY .= "\n\n</SCRIPT>\n\n";

} // End Step Two

// =================================================================================================
//
//   ########
//         ##
//         ##
//      #####
//         ##
//         ##
//         ## 
//    #######
//
// =================================================================================================

if ($STEP_NUM == "3") {

	$THIS_DISPLAY .= "\n\n<!-- ----------------- START STEP 3 ---------------------- -->\n\n";
	
	$THIS_DISPLAY .= "<FORM NAME=field_data METHOD=POST ACTION=\"create_campaign.php\">\n";
	$THIS_DISPLAY .= "<INPUT TYPE=HIDDEN NAME=STEP_NUM VALUE=4>\n";
	$THIS_DISPLAY .= $HIDDEN_POST;
	
	$THIS_DISPLAY .= "<TABLE BORDER=0 CELLPADDING=10 CELLSPACING=0 CLASS=text WIDTH=650 BGCOLOR=#EFEFEF STYLE='BORDER: 1px inset black;'>\n";
	$THIS_DISPLAY .= "<TR>\n";
	$THIS_DISPLAY .= "<TD ALIGN=LEFT VALIGN=MIDDLE>\n";
	$THIS_DISPLAY .= "<FONT STYLE='font-size: 11pt;'><TT><U>STEP 3 OF 5</U> : OWNER INFORMATION</B></TT></FONT>\n";
	$THIS_DISPLAY .= "</TD></TR></TABLE>\n";
	
	$THIS_DISPLAY .= "<TABLE BORDER=0 CELLPADDING=10 CELLSPACING=0 CLASS=text WIDTH=650 STYLE='border: 1px inset black;'>\n";
	$THIS_DISPLAY .= "<TR>\n";
	$THIS_DISPLAY .= "<TD ALIGN=LEFT VALIGN=TOP BGCOLOR=WHITE CLASS=text>\n";
	
		$THIS_DISPLAY .= "This campaign will arrive as an email to your list. Please indicate what email address it will<BR>come from and the subject line: \n";
		
		$THIS_DISPLAY .= "<BR><BR>A. <U>From</U> email address: \n";
		$THIS_DISPLAY .= "<BR><INPUT TYPE=TEXT CLASS=text NAME=FROM_EMAIL VALUE=\"webmaster@$SERVER_NAME\" STYLE='WIDTH: 200px;'>\n";

		$MONTH = date("F");
		
		$THIS_DISPLAY .= "<BR><BR><BR>B. <U>Subject Line</U> of this campaign: \n";
		$THIS_DISPLAY .= "<BR><INPUT TYPE=TEXT CLASS=text NAME=SUBJECT_LINE VALUE=\"$MONTH Newsletter\" STYLE='WIDTH: 200px;'>\n";

		$THIS_DISPLAY .= "<BR><BR><BR><BR><DIV ALIGN=RIGHT><INPUT TYPE=SUBMIT VALUE=\" Next >> \" CLASS=FormLt1></DIV>\n\n";
		
	$THIS_DISPLAY .= "</TD></TR></TABLE>\n";
	
	$THIS_DISPLAY .= "</FORM>";

	$THIS_DISPLAY .= "\n\n<!-- ------------------ END STEP 3 ----------------------- -->\n\n";	
	
} // End Step Three

// =================================================================================================
//
//   ##    ##
//   ##    ##
//   ##    ##
//   ########
//         ##
//         ##
//         ## 
//         ##
//
// =================================================================================================

if ($STEP_NUM == "4") {

	#######################################################
	### POPULATE DROP DOWN VAR WITH ALL NEWSLETTER PAGES
	#######################################################
	
	$PAGES = "     <OPTION VALUE=\"\" STYLE='color: #999999;'>Newsletter Content Pages:</OPTION>\n"; 
	$PAGES .= "     <OPTION VALUE=\"NONE\" STYLE='background: #EFEFEF;'>[NONE] Template Contains Content</OPTION>\n";    

	$row_color = "#EFEFEF";

	$result = mysql_query("SELECT page_name FROM site_pages WHERE type = 'newsletter'");
	while ($row = mysql_fetch_array($result)) {
		if ($row_color == "white") { $row_color = "#EFEFEF"; } else { $row_color = "white"; }
		$PAGES .= "     <OPTION VALUE=\"$row[page_name]\" style='background: $row_color;'>$row[page_name]</OPTION>\n";
	}

	#######################################################
	### POPULATE DROP DOWN VAR AVAILABLE TEMPLATES.
	### FOR NEWSLETTERS, THERE IS ONLY  A SIGLE "STANDARD"
	### TEMPLATE INCLUDED WITH RELEASE.  MORE ARE AVAIL
	### AT THE DEVNET.
	#######################################################

	$TEMPLATES .= "     <option value=\"\" STYLE='color: #999999;'>HTML Newsletter Templates:</option>\n";
	
	$directory = "$doc_root/media";
	if (is_dir($directory)) {
		$handle = opendir("$directory");
		while ($files = readdir($handle)) {
			if (strlen($files) > 2 && eregi("\.html", $files)) {
				$TEMPLATES .= "     <option value=\"$directory/$files\">$files</option>\n";
			}
		}	
		closedir($handle);
	}
	
	#######################################################
		
	
	$THIS_DISPLAY .= "\n\n<!-- ----------------- START STEP 4 ---------------------- -->\n\n";
	
	$THIS_DISPLAY .= "<FORM NAME=field_data METHOD=POST ACTION=\"create_campaign.php\">\n";
	$THIS_DISPLAY .= "<INPUT TYPE=HIDDEN NAME=STEP_NUM VALUE=5>\n";
	$THIS_DISPLAY .= $HIDDEN_POST;
	
	$THIS_DISPLAY .= "<TABLE BORDER=0 CELLPADDING=10 CELLSPACING=0 CLASS=text WIDTH=650 BGCOLOR=#EFEFEF STYLE='BORDER: 1px inset black;'>\n";
	$THIS_DISPLAY .= "<TR>\n";
	$THIS_DISPLAY .= "<TD ALIGN=LEFT VALIGN=MIDDLE>\n";
	$THIS_DISPLAY .= "<FONT STYLE='font-size: 11pt;'><TT><U>STEP 4 OF 5</U> : HTML CONTENT</B></TT></FONT>\n";
	$THIS_DISPLAY .= "</TD></TR></TABLE>\n";
	
	$THIS_DISPLAY .= "<TABLE BORDER=0 CELLPADDING=10 CELLSPACING=0 CLASS=text WIDTH=650 STYLE='border: 1px inset black;'>\n";
	$THIS_DISPLAY .= "<TR>\n";
	$THIS_DISPLAY .= "<TD ALIGN=LEFT VALIGN=TOP BGCOLOR=WHITE CLASS=text>\n";
	
	
	$THIS_DISPLAY .= "Please select the template file and page name which contains the enewsletter content for<BR>sending the HTML version of this campaign: \n";
			
		$THIS_DISPLAY .= "<BR><BR>A. Select the template to use with this campaign: \n";
		$THIS_DISPLAY .= "<BR><SELECT NAME=\"TEMPLATE_NAME\" STYLE='FONT-FAMILY: Arial; FONT-SIZE: 8pt; WIDTH: 300px;'>$TEMPLATES</SELECT>\n";

		$THIS_DISPLAY .= "<BR><BR>B. Select the newsletter attachement page to use for content: \n";
		$THIS_DISPLAY .= "<BR><SELECT NAME=\"PAGE_NAME\" STYLE='FONT-FAMILY: Arial; FONT-SIZE: 8pt; WIDTH: 300px;'>$PAGES</SELECT> &nbsp;&nbsp; [ <a href=\"#\" onclick=\"prev_sel();\">Preview Selections</a> ]\n";

	$THIS_DISPLAY .= "<BR><BR><BR><BR><DIV ALIGN=RIGHT><INPUT TYPE=BUTTON VALUE=\" Next >> \" CLASS=FormLt1 ONCLICK=\"step4();\"></DIV>\n\n";
		
	$THIS_DISPLAY .= "</TD></TR></TABLE>\n";
	
	$THIS_DISPLAY .= "</FORM>";

	$THIS_DISPLAY .= "\n\n<!-- ------------------ END STEP 4 ----------------------- -->\n\n";	
	


} // End Step Four

// =================================================================================================
//
//   ########
//   ##    
//   ##    
//   ########
//         ##
//         ##
//         ## 
//   ########
//
// =================================================================================================

if ($STEP_NUM == "5") {

		########################################################################
		### SETUP DEFAULT TEXT CONTENT FOR USER TO EDIT TO HIS/HER LIKING.
		### THIS ALSO GIVES US THE CHANCE TO "SHOW" HOW THEY CAN ENTER VARIABLES
		### THAT WILL BE CHANGED BASED ON BUILD ROUTINE.
		########################################################################
		
		$MONTH = strtoupper(date("F"));
		$THIS_SITE = strtoupper($SERVER_NAME);
		
		$DEF_TEXT = "\n\n$THIS_SITE $MONTH NEWSLETTER\n";
		$DEF_TEXT .= "---------------------------------------------------------------------------------\n\n";
		$DEF_TEXT .= "blah, blah, blah, blah, blah, blah, blah, blah, blah, blah, ";
		$DEF_TEXT .= "blah, blah, blah, blah, blah, blah, blah, blah, blah, blah, ";
		$DEF_TEXT .= "blah, blah, blah, blah, blah, blah, blah, blah, blah, blah, ";
		$DEF_TEXT .= "blah, blah, blah, blah, blah, blah, blah, blah, blah, blah, ";
		$DEF_TEXT .= "blah, blah, blah, blah, blah, blah, blah, blah, blah, blah. \n\n";
		$DEF_TEXT .= "To view our HTML version, point your browser to:\n";
		$DEF_TEXT .= "http://$this_ip/subscription/index.php?id=[THIS_ID]\n\n";
		$DEF_TEXT .= "If you do not wish to receive this newsletter,\nunsubscribe to this service by going to:\n";
		$DEF_TEXT .= "http://$this_ip/subscription/index.php?id=unsubscribe\n\n";
		

	$THIS_DISPLAY .= "\n\n<!-- ----------------- START STEP 5 ---------------------- -->\n\n";
	
	$THIS_DISPLAY .= "<FORM NAME=field_data METHOD=POST ACTION=\"create_campaign.php\">\n";
	$THIS_DISPLAY .= "<INPUT TYPE=HIDDEN NAME=STEP_NUM VALUE=6>\n";
	$THIS_DISPLAY .= $HIDDEN_POST;
	
	$THIS_DISPLAY .= "<TABLE BORDER=0 CELLPADDING=10 CELLSPACING=0 CLASS=text WIDTH=650 BGCOLOR=#EFEFEF STYLE='BORDER: 1px inset black;'>\n";
	$THIS_DISPLAY .= "<TR>\n";
	$THIS_DISPLAY .= "<TD ALIGN=LEFT VALIGN=MIDDLE>\n";
	$THIS_DISPLAY .= "<FONT STYLE='font-size: 11pt;'><TT><U>STEP 5 OF 5</U> : TEXT CONTENT</B></TT></FONT>\n";
	$THIS_DISPLAY .= "</TD></TR></TABLE>\n";
	
	$THIS_DISPLAY .= "<TABLE BORDER=0 CELLPADDING=10 CELLSPACING=0 CLASS=text WIDTH=650 STYLE='border: 1px inset black;'>\n";
	$THIS_DISPLAY .= "<TR>\n";
	$THIS_DISPLAY .= "<TD ALIGN=LEFT VALIGN=TOP BGCOLOR=WHITE CLASS=text>\n";
	
	
	$THIS_DISPLAY .= "For those users that have selected to receive text only campaigns, please create the text that will be sent to those users as well as embedded in the header of the HTML newsletter in case of errors: \n";
			
		$THIS_DISPLAY .= "<BR><BR><TEXTAREA NAME=\"TEXT_EMAIL\" STYLE='background: #EFEFEF; width: 612; height: 225; font-family: Arial; font-size: 8pt;' WRAP=VIRTUAL>$DEF_TEXT</TEXTAREA>\n";

	$THIS_DISPLAY .= "<BR><BR><BR><BR><DIV ALIGN=RIGHT><INPUT TYPE=SUBMIT VALUE=\" Create Campaign \" CLASS=FormLt1>\n";
	$THIS_DISPLAY .= "<BR><FONT COLOR=#999999>Creating the campaign does NOT send emails now.</FONT></DIV>\n\n";
		
	$THIS_DISPLAY .= "</TD></TR></TABLE>\n";
	
	$THIS_DISPLAY .= "</FORM>";

	$THIS_DISPLAY .= "\n\n<!-- ------------------ END STEP 5 ----------------------- -->\n\n";	
	


} // End Step Five

// =================================================================================================
//
//   ########
//   ##    
//   ##    
//   ########
//   ##    ##
//   ##    ##
//   ##    ## 
//   ########
//
// =================================================================================================

if ($STEP_NUM == "6") {

		########################################################################
		### TIME TO "BUILD" THE CAMPAIGN ::
		### Grab all the passed variable data from the wizard posts and place
		### it in a variable for save
		########################################################################
		
		$WIZ_VARS = "";
		
		reset($HTTP_POST_VARS);
		while (list($name, $value) = each($HTTP_POST_VARS)) {
			$value = stripslashes($value);			// Strip all slashes from data for insurance
			$value = addslashes($value);			// Add clean slashes for database insert
			$WIZ_VARS .= "$name=$value\n";
			// $THIS_DISPLAY .= "<B>$name</b>:<BR>$value<HR>";
		}
		
		########################################################################
		### GET EMAIL ADDRESSES AND BUILD "Bcc:" ARRAY FOR TEXT/HTML
		########################################################################
		
		for ($z=1;$z<=100;$z++) {		// Reset up to 100,000 names
			$HTML_EMAIL_ADDR[$z] = "";
			$TEXT_EMAIL_ADDR[$z] = "";
		}
		
		$NUM_HTML_CNT = 0;
		$NUM_TEXT_CNT = 0;
		
		// -------------------------------------
		// Search for HTML signup's first
		// -------------------------------------
		
			if ($USER_SEND_TYPE != "") { 
			
				$TYPE_FN = ", $USER_SEND_TYPE";
				$WHERE_CLAUSE = "WHERE $USER_SEND_TYPE LIKE 'H%' OR $USER_SEND_TYPE LIKE 'h%'"; 
				
			} else {
			
			 	$TYPE_FN = "";
				$WHERE_CLAUSE = "";
				
			}

			$tmp_query = "SELECT DISTINCT $USER_EMAIL_ADDRESS $TYPE_FN FROM $TABLE_NAME $WHERE_CLAUSE";
			$result = mysql_query("$tmp_query");

			// Build HTML Send Email Addresses.  Because SENDMAIL has a limit to the header size
			// within each email sent from the system, we will need to create an array so that
			// we are actually sending our newsletter in chuncks of 1000 each.  This will handle
			// "large" databased listings
			
			$chunk_array = 1;	// Base array
			$chunk_count = 0;	// Reset Counter
			
			while ($row = mysql_fetch_array($result)) {
					$noflag = 0;
					
					// Check all users against unsubscribe list and only add them to our
					// new campaign if they have NOT unsubscribed.
					
					$unsub = mysql_query("SELECT UNSUB_EMAIL_ADDR FROM UNSUBSCRIBE");
					while($tmp = mysql_fetch_array($unsub)) {
						$tt = rtrim($row[$USER_EMAIL_ADDRESS]);
						$ttt = rtrim($tmp[UNSUB_EMAIL_ADDR]);
						if (eregi("$tt", $ttt)) { $noflag = 1; }	// If they have unsub - turn noflag on
					} // End While $tmp

					// Check for possible character problems with SENDMAIL program.  If spaces exist,
					// or no at (@) sign exists in the email address, SENDMAIL will halt
					// the sending of the entire batch.
					
					$row[$USER_EMAIL_ADDRESS] = eregi_replace(" ", "_", $row[$USER_EMAIL_ADDRESS]);
					$row[$USER_EMAIL_ADDRESS] = eregi_replace("'", "", $row[$USER_EMAIL_ADDRESS]);		// Fix appostrophe bug.  See Bugzilla #5
					$row[$USER_EMAIL_ADDRESS] = eregi_replace("\"", "", $row[$USER_EMAIL_ADDRESS]);
					
					if (!eregi("@", $row[$USER_EMAIL_ADDRESS])) { $noflag = 1; }
					
					// If previous checksums are met, add this user to our send address list
					
					if (strlen($row[$USER_EMAIL_ADDRESS]) > 3 && $noflag == 0) {						// Make sure we don't have a blank field here
					
						
								
						$HTML_EMAIL_ADDR[$chunk_array] .= "$row[$USER_EMAIL_ADDRESS]; ";
						$NUM_HTML_CNT++;	// True count of "recipients" added to campaign
						
						// Check our Chunk counts; only sending in chunks of 1000
							
							$chunk_count++;							
							if ($chunk_count > 499) {
							
								// Remove last ";" from array 
								
								$tmp = strlen($HTML_EMAIL_ADDR[$chunk_array]);
								$new = $tmp - 2;
								$HTML_EMAIL_ADDR[$chunk_array] = substr($HTML_EMAIL_ADDR[$chunk_array], 0, $new);
							
								$chunk_count = 0;
								$chunk_array++;
								
							}
							
					}
					
			}
		
			
			$tmp = strlen($HTML_EMAIL_ADDR[$chunk_array]);
			$new = $tmp - 2;
			if (substr($HTML_EMAIL_ADDR[$chunk_array], $new, $tmp) == "; ") {
				$HTML_EMAIL_ADDR[$chunk_array] = substr($HTML_EMAIL_ADDR[$chunk_array], 0, $new);
			}
			
			$number_chunks = $chunk_array;			
			$err_html = $tmp_query;
			
			// If we have HTML sends, then let's create a temporary send table for the chunks that we have
			
			if ($NUM_HTML_CNT > 0) {
			
				$sql_field_string = "";
				for ($z=1;$z<=$number_chunks;$z++) {
				
					$sql_field_string .= "CHUNK_$z BLOB";
					$sql_value_string .= "'$HTML_EMAIL_ADDR[$z]'";
					
					if ($z != $number_chunks) { 
						$sql_field_string .= ", "; 
						$sql_value_string .= ", ";
					}
					
				} // End Chunk Loop
				
				$tmp = date("Ymdgia");
				$this_table = "$CAMPAIGN_NAME".$tmp;
				$this_table = md5($this_table);
				$this_table = "CTEMP_".$this_table;
		
				mysql_db_query("$db_name","CREATE TABLE $this_table ($sql_field_string)");
	
				// populate the table with chunk data
				
				mysql_query("INSERT INTO $this_table VALUES($sql_value_string)");
				
				$HTML_EMAIL_ADDR_KEY = $this_table;
			
			}
			
		
		// ----------------------------------------------------------------------------------
		// Now search for TEXT signup's (Only perform this search if $TYPE has been defined
		// ----------------------------------------------------------------------------------
		
			if ($USER_SEND_TYPE != "") { 
			
				$TYPE_FN = ", $USER_SEND_TYPE";
				$WHERE_CLAUSE = "WHERE $USER_SEND_TYPE LIKE 'T%' OR $USER_SEND_TYPE LIKE 't%'";				

				$tmp_query = "SELECT DISTINCT $USER_EMAIL_ADDRESS $TYPE_FN FROM $TABLE_NAME $WHERE_CLAUSE";
				$result = mysql_query("$tmp_query");

				// Not going to worry about "chunking" text emails; they are limited in volume
				// so it is VERY rare that you have over 1000 text email subscribers
				
				while ($row = mysql_fetch_array($result)) {
					$noflag = 0;
					// Check all users against unsubscribe list and only add them to our
					// new campaign if they have NOT unsubscribed.
					
					$unsub = mysql_query("SELECT UNSUB_EMAIL_ADDR FROM UNSUBSCRIBE");
					while($tmp = mysql_fetch_array($unsub)) {
						$tt = rtrim($row[$USER_EMAIL_ADDRESS]);
						$ttt = rtrim($tmp[UNSUB_EMAIL_ADDR]);
						if (eregi("$tt", $ttt)) { $noflag = 1; }	// If they have unsub - turn noflag on
					} // End While $tmp

					// Check for possible problems with SENDMAIL program.  If spaces exist
					// or no at (@) sign exists in the email address, SENDMAIL will halt
					// the sending of the entire batch.
					
					$row[$USER_EMAIL_ADDRESS] = eregi_replace(" ", "_", $row[$USER_EMAIL_ADDRESS]);
					if (!eregi("@", $row[$USER_EMAIL_ADDRESS])) { $noflag = 1; }
					
					// If previous checksums are met, add this user to our send address list
					
					if (strlen($row[$USER_EMAIL_ADDRESS]) > 3 && $noflag == 0) {	// Make sure we don't have a blank field here also
						$HTML_TEXT_ADDR .= "$row[$USER_EMAIL_ADDRESS]; ";
						$NUM_TEXT_CNT++;							
					}
					
				}
		
				$tmp = strlen($HTML_TEXT_ADDR);
				$new = $tmp - 2;
				$HTML_TEXT_ADDR = substr($HTML_TEXT_ADDR, 0, $new);
				
				$err_text = $tmp_query;
				
			} // End if type isset

		########################################################################
		### MAKE SURE WE HAVE EMAIL ADDRESSES TO SEND TO IN THIS CAMPAIGN
		########################################################################
		
		if ($NUM_HTML_CNT == 0 && $NUM_TEXT_CNT == 0) {
				echo "<H3><font face=verdana>Error: This campaign does not appear to have any email addresses to send to...</font></H3>";
				echo "<BR><BR>HTML Types found: $HTML_EMAIL_ADDR ($NUM_HTML_CNT)<BR>TEXT Types found: $HTML_TEXT_ADDR ($NUM_TEXT_CNT)";
				echo "<BR><BR>DevString:<BR>HTML: $err_html<BR><BR>TEXT: $err_text";
				exit;
		}
		
		########################################################################
		### GET HTML NEWSLETTER CONTENT AND TEMPLATE
		########################################################################
		
		$filename = "$TEMPLATE_NAME";
		$file = fopen("$filename", "r");
			$TEMPLATE_BODY = fread($file,filesize($filename));
		fclose($file);
						
		if ($PAGE_NAME == "NONE") {				// This is a custom template only HTML newsletter
						
				$HTML_CONTENT = $TEMPLATE_BODY;
				
		} else {
		
				// ------------------------------------------------------------------------
				// More complex; this is a tool generated email with template selection
				// Step 1: Read Template into tmp_variable
				// ------------------------------------------------------------------------
		
				$tmp = split("/", $TEMPLATE_NAME);
				$tmpc = count($tmp) - 1;
				$this_template = $tmp[$tmpc];
								
				$this_page = eregi_replace(" ", "_", $PAGE_NAME);
				$filename = "http://$this_ip/index.php?pr=$this_page&news_force_template=$this_template";
				
				ob_start(); 
					include("$filename");
					$HTML_CONTENT = ob_get_contents(); 
				ob_end_clean(); 
				
				// ------------------------------------------------------------------------
				// Replace Newsletter Template Variable Data with appropriate values now
				// ------------------------------------------------------------------------
				
				$this_title = strtoupper($SERVER_NAME);
				$HTML_CONTENT = eregi_replace("#TITLE#", "$this_title", $HTML_CONTENT);
				$HTML_CONTENT = eregi_replace("#UNSUBSCRIBE#", "news?=unsubscribe", $HTML_CONTENT);
			
		} // End Custom / Tool Generation Check
		
		$HTML_CONTENT = eregi_replace("http://$this_ip/", "", $HTML_CONTENT);	// Clean any images added to Word Processor after compiling full page
				
		// For Display Test Only -- Comment out for final build
				
		// $preview_html = eregi_replace("src=\"", "src=\"http://$this_ip/", $HTML_CONTENT);
		// $preview_html = eregi_replace("href=\"", "href=\"http://$this_ip/", $preview_html);
		// $THIS_DISPLAY .= "<br>$preview_html<hr>";		
		
		########################################################################
		### LET'S BUILD THE IMAGE_ARRAY VAR SO WE KNOW WHAT IMAGES TO MIME
		### ENCODE WITH THE EMAIL SEND
		########################################################################
				
		$work_html = eregi_replace(">", ">\n", $HTML_CONTENT);		// Make sure that all image calls are on a single line by themselves
		$work_html = eregi_replace("<", "\n<", $work_html);
		
		$IMAGE_ARRAY = "";			// Set main array build var to empty
		
		$html_line = split("\n", $work_html);
		$lc = count($html_line);
		
		for ($x=0;$x<=$lc;$x++) {	// Start loop thru each html line
		
			if (eregi("\.gif", $html_line[$x]) || eregi("\.jpg", $html_line[$x])) { 	// This line contains an image filename

				$tmp = split(" ", $html_line[$x]);	// One more step; split this line by spaces
				$tmpc = count($tmp);
				$this_image = "";					// Clear var before next find
				
				for ($y=0;$y<=$tmpc;$y++) {
				
						if (eregi("\.gif", $tmp[$y]) || eregi("\.jpg", $tmp[$y])) {

							$tmp_find = eregi("src=(.*)", $tmp[$y], $out);
							$this_image = $out[1];
							
							if ($this_image == "") {		// If not normal img tag; must be background tag
								$tmp_find = eregi("background=\"(.*)\"", $out, $tmp[$y]);
								$this_image = $out[1];
							}
							
						} // End if GIF or JPG found inside HTML TAG
				} // End $y Loop
				
				$this_image = eregi_replace("\"", "", $this_image);	// Remove quotes from image name (bi-product of effective image find)
				$this_image = eregi_replace("'", "", $this_image);			// Remove single-quotes from image name (bi-product of effective image find)
				// $this_image = eregi_replace("/images", "", $this_image);	// Remove images folder for dumb shits like me... I goofed

				if ($this_image != "" && !eregi("$this_image", $IMAGE_ARRAY)) {						
						// $IMAGE_ARRAY .= $doc_root . "/images/" . $this_image . ";";
						$IMAGE_ARRAY .= $doc_root . "/" . $this_image . ";";
				}
				
			} // End if GIF or JPG found in this line
		} // End $x loop through each HTML line
		
		
		// The next two lines are for dev purposes and should be commented out for final build
		// $image_test = eregi_replace(";", "<BR>", $IMAGE_ARRAY);
		// echo "<BR>Images:<BR><BR>$image_test<BR>";
		// exit;
			
		########################################################################
		### EMBED TEXT CONTENT VALUE INTO HTML CODE [Head off MIME errors]
		########################################################################	
				
		$HTML_CONTENT = "<!--\n\n$TEXT_EMAIL\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n -->\n\n\n\n" . $HTML_CONTENT;
		
		########################################################################
		### ADD CAMPAIGN TO CAMPAIN_MANAGER TABLE NOW
		########################################################################
		
		// ----------------------------------------------------
		// Make sure all values are insertable
		// ----------------------------------------------------
		
		$CAMPAIGN_NAME = addslashes($CAMPAIGN_NAME);
		$HTML_EMAIL_ADDR_KEY = addslashes($HTML_EMAIL_ADDR_KEY);
		$TEXT_EMAIL_ADDR = addslashes($HTML_TEXT_ADDR);
		$SUBJECT_LINE = addslashes($SUBJECT_LINE);
		$HTML_CONTENT = addslashes($HTML_CONTENT);
		$WIZ_VARS = addslashes($WIZ_VARS);
		$TEXT_EMAIL = addslashes($TEXT_EMAIL);
		
		// ----------------------------------------------------
		
		$SQL_INSERT = "INSERT INTO CAMPAIGN_MANAGER VALUES('NULL', 'Pending', '$CAMPAIGN_NAME', '$TABLE_NAME', ";
		$SQL_INSERT .= "'$HTML_EMAIL_ADDR_KEY~~~$number_chunks', '$TEXT_EMAIL_ADDR', '$FROM_EMAIL', '$SUBJECT_LINE', '$HTML_CONTENT', ";
		$SQL_INSERT .= "'$IMAGE_ARRAY', '$WIZ_VARS', '$TEXT_EMAIL', '$NUM_HTML_CNT', '$NUM_TEXT_CNT', '0000-00-00', '0', 'N')";
		
		// Test Line only - comment out for final build
		// $THIS_DISPLAY .= "<TEXTAREA STYLE='WIDTH: 500px; HEIGHT: 300px;'>$SQL_INSERT</TEXTAREA>\n";
		
		mysql_query("$SQL_INSERT") || DIE("<H4>Error Writing to Data Table (Could not create campaign): This is a programming error, consult with your webmaster.</H4>");
		
		########################################################################
		### AND I'M SPENT...
		########################################################################
		
		$THIS_DISPLAY .= "<BR><BR><BR><BR><BR><BR><H2><FONT COLOR=DARKBLUE>Campaign Created!</FONT></H2>\n\n";
		$THIS_DISPLAY .= "<FORM METHOD=POST ACTION=\"../enewsletter.php\">\n";
		$THIS_DISPLAY .= "<INPUT TYPE=SUBMIT CLASS=FormLt1 VALUE=\" Campaign Manager \"></FORM>\n\n";
		$THIS_DISPLAY .= "<DIV STYLE='font-size: 10pt;'>\n";
		$THIS_DISPLAY .= "Your campaign has been added with pending status.  You may now preview or<BR>SEND your campaign from the \"Campaign Manager\" Interface.\n";
		$THIS_DISPLAY .= "</DIV>\n";

} // End Step Six

##############################################################################################
### FOR VISUAL CONSISTANCY; WE USE AN HTML TEMPLATE BUILDER FILE 
### LOCATED IN THE /shared FOLDER.  THIS WAY ALL OF OUR MODULE 
### INTERFACES LOOK THE SAME. YOU MUST SUPPLY THE VARIABLES:
###
### $MOD_TITLE		Title of this Module
### $THIS_DISPLAY		HTML Content to display to end user
### $BG 			Background Image for content table if used
###
### THIS SAME METHOD SHOULD BE USED WHEN BUILDING ANY OF YOUR OWN 
### CUSTOM MODULES.  REMEMBER TO INCLUDE THE HEADER "INCLUDES"
### ABOVE FOR PROPER FUNCTIONALITY WITHIN THE APPLICAITON.
#############################################################################################

include("shared/html_build.php");

#############################################################################################

?>

</div>

</body>

<!-- <HEAD>
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE"></HEAD> -->

</html>