<?php

###############################################################################
## Soholaunch(R) Site Management Tool
## Version 4.5
##      
## Author: 			Mike Johnston [mike.johnston@soholaunch.com]                 
## Homepage:	 	http://www.soholaunch.com
## Bug Reports: 	http://bugzilla.soholaunch.com
## Release Notes:	sohoadmin/build.dat.php
###############################################################################

##############################################################################
## COPYRIGHT NOTICE                                                     
## Copyright 1999-2003 Soholaunch.com, Inc.  All Rights Reserved.       
##                                                                        
## This script may be used and modified in accordance to the license      
## agreement attached (license.txt) except where expressly noted within      
## commented areas of the code body. This copyright notice and the comments  
## comments above and below must remain intact at all times.  By using this 
## code you agree to indemnify Soholaunch.com, Inc, its coporate agents   
## and affiliates from any liability that might arise from its use.                                                        
##                                                                           
## Selling the code for this program without prior written consent is       
## expressly forbidden and in violation of Domestic and International 
## copyright laws.  		                                           
###############################################################################

session_start();
include("includes/login.php");
include("includes/db_connect.php");

##########################################################################
### INSERT FUNCTION TO KILL ALL NON ALPHA/NUMERIC CHARACTERS FROM DATA
### FOR DATABASE STORAGE
##########################################################################

function sterilize_char ($sterile_var) {

	$sterile_var = stripslashes($sterile_var);
	$sterile_var = eregi_replace(" ", "_", $sterile_var);
	$sterile_var = eregi_replace("#", "", $sterile_var);

	$st_l = strlen($sterile_var);
	$st_a = 0;
	$tmp = "";

	while($st_a != $st_l) {
		$temp = substr($sterile_var, $st_a, 1);
		if (eregi("[0-9a-z_]", $temp)) { $tmp .= $temp; }
		$st_a++;
	}

	$sterile_var = $tmp;
	return $sterile_var;

}

##########################################################################

$MOD_TITLE = "Template Builder";

#######################################################
### BUILD SAVE NEW TEMPLATE ROUTINE 	 		    ###	
#######################################################

if ($BUILDER == "ACTIVE") {		// Do Save

		// Step 1: Process Passed Data 
		// ----------------------------------------------------------------------------
			
		reset($HTTP_POST_VARS);
		while (list($name, $value) = each($HTTP_POST_VARS)) {
			$name = stripslashes($name);
			$value = stripslashes($value);
			if ($name != "IMAGE") { $value = sterilize_char($value); }
			${$name} = $value;
		}

		
		// Step 2: Read Base HTML into memory 
		// ----------------------------------------------------------------------------
		
		ob_start(); 
			include("shared/base.html");
			$template_html = ob_get_contents(); 
		ob_end_clean(); 

		// Step 3: Build Section Colors (Use Text Areas in case of custom colors)
		// ----------------------------------------------------------------------------
		
		if ($TEMP_STYLE == "BLANK") {
			$SECTION1 = $BCOLOR;
			$SECTION2 = $BCOLOR;
			$SECTION3 = $BCOLOR;
			$SECTION4 = $BCOLOR;
			$SECTION5 = $BCOLOR;
			$SECTION6 = $BCOLOR;
		}
		
		if ($TEMP_STYLE == "LEFTBAR") {
			$SECTION1 = $FCOLOR;
			$SECTION2 = $BCOLOR;
			$SECTION3 = $FCOLOR;
			$SECTION4 = $BCOLOR;
			$SECTION5 = $FCOLOR;
			$SECTION6 = $BCOLOR;
		}
		
		if ($TEMP_STYLE == "LSHAPE") {
			$SECTION1 = $FCOLOR;
			$SECTION2 = $FCOLOR;
			$SECTION3 = $FCOLOR;
			$SECTION4 = $BCOLOR;
			$SECTION5 = $FCOLOR;
			$SECTION6 = $BCOLOR;
		}
		
		if ($TEMP_STYLE == "USHAPE") {
			$SECTION1 = $FCOLOR;
			$SECTION2 = $FCOLOR;
			$SECTION3 = $FCOLOR;
			$SECTION4 = $BCOLOR;
			$SECTION5 = $FCOLOR;
			$SECTION6 = $FCOLOR;
		}
		
		if ($TEMP_STYLE == "PRO") {
			$SECTION1 = $FCOLOR;
			$SECTION2 = $FCOLOR;
			$SECTION3 = $BCOLOR;
			$SECTION4 = $BCOLOR;
			$SECTION5 = $FCOLOR;
			$SECTION6 = $FCOLOR;
		}
	
		// Step 4: Apply Selections to template HTML in memory
		// -------------------------------------------------------------------

		$template_html = eregi_replace("#SEC1#", "#$SECTION1", $template_html);
		$template_html = eregi_replace("#SEC2#", "#$SECTION2", $template_html);
		$template_html = eregi_replace("#SEC3#", "#$SECTION3", $template_html);
		$template_html = eregi_replace("#SEC4#", "#$SECTION4", $template_html);
		$template_html = eregi_replace("#SEC5#", "#$SECTION5", $template_html);
		$template_html = eregi_replace("#SEC6#", "#$SECTION6", $template_html);
		
		$template_html = eregi_replace("#FCOLOR#", "#$FCOLOR", $template_html);
		$template_html = eregi_replace("#BCOLOR#", "#$BCOLOR", $template_html);
		$template_html = eregi_replace("#TCOLOR#", "#$TCOLOR", $template_html);
		$template_html = eregi_replace("#TXTCOLOR#", "#$TXTCOLOR", $template_html);
		$template_html = eregi_replace("#LCOLOR#", "#$LCOLOR", $template_html);
		$template_html = eregi_replace("#IMAGE#", "$IMAGE", $template_html);

		// Step 5: Create Custom Custom HTML File
		// -------------------------------------------------------------------
		
			$TEMP_NAME = eregi_replace(" ", "_", $TEMP_NAME);
			$nfilename = $doc_root."/tCustom/".$TEMP_NAME.".html";
		
		$nfile = fopen("$nfilename", "w");
			$template_html = "<!-- This file created with the Soholaunch Template Creator -->\n\n\n\n\n\n".$template_html;
			fwrite($nfile, "$template_html\n");
		fclose($nfile);
		
		// Step 6: Send user back to template selection screen
		// -------------------------------------------------------------------		

		header("Location: ../site_templates.php?=SID");
		exit;
	
} // End Save

#######################################################
### GET COLOR TABLE						 		    ###	
#######################################################

$filename = "shared/color_table.dat";
$fp = fopen("$filename", "r");
	$colors = fread($fp, filesize("$filename")); 
fclose($fp);

$color = split("\n", $colors);
$clr_cnt = count($color);

$COPTIONS = "";

for ($x=0;$x<=$clr_cnt;$x++) {
	$tmp = split(",", $color[$x]);
	if ($tmp[0] != "") {
		$tmp[1] = chop($tmp[1]);
		$COPTIONS .= "<OPTION VALUE=\"$tmp[1]\">$tmp[0]</OPTION>\n";
	}
}

##################################################################################
### READ IMAGE FILES INTO MEMORY			    
##################################################################################

$img_selection = "     <OPTION VALUE=\"NOIMAGE\">[No Image]</OPTION>\n";

// Uploaded Images
// -------------------------------------------------------------------------------

$count = 0;
$directory = "$doc_root/images";
$handle = opendir("$directory");
	while ($files = readdir($handle)) {
		if (strlen($files) > 2) {
			$count++;
			$imageFile[$count] = ucwords($files) . "~~~" . $files;
		}
	}
$numImages = $count;
closedir($handle);

// Library Images
// -------------------------------------------------------------------------------
/*
$directory = "library/Abstract";
$handle = opendir("$directory");
	while ($files = readdir($handle)) {
		if (strlen($files) > 2) {
			$count++;
			$imageFile[$count] = "[Abstract] " . ucwords($files) . "~~~" . $files;
		}
	}
$numImages = $count;
closedir($handle);
*/


if ($count != 0) {
	sort($imageFile);
	if ($count == 1) {
		$imageFile[0] = $imageFile[1];
	}
	$numImages--;	
}


for ($x=0;$x<=$numImages;$x++) {

	$thisImage = split("~~~", $imageFile[$x]);
	$img_selection .= "     <OPTION VALUE=\"$thisImage[1]\">$thisImage[0]</OPTION>\n";
}

#######################################################
### START HTML/JAVASCRIPT CODE			 		    ###	
#######################################################

?>

<HTML>
<HEAD>
<TITLE>SOHOLAUNCH MODULE</TITLE>

<META HTTP-EQUIV="Content-Type" content="text/html; charset=iso-8859-1">
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<META HTTP-EQUIV="Expires" CONTENT="-1">

<link rel="stylesheet" href="shared/soholaunch.css">

<script language="JavaScript">
<!--
function SV2_findObj(n, d) { //v3.0
  var p,i,x;  if(!d) d=document; if((p=n.indexOf("?"))>0&&parent.frames.length) {
    d=parent.frames[n.substring(p+1)].document; n=n.substring(0,p);}
  if(!(x=d[n])&&d.all) x=d.all[n]; for (i=0;!x&&i<d.forms.length;i++) x=d.forms[i][n];
  for(i=0;!x&&d.layers&&i<d.layers.length;i++) x=SV2_findObj(n,d.layers[i].document); return x;
}
function SV2_showHideLayers() { //v3.0
  var i,p,v,obj,args=SV2_showHideLayers.arguments;
  for (i=0; i<(args.length-2); i+=3) if ((obj=SV2_findObj(args[i]))!=null) { v=args[i+2];
    if (obj.style) { obj=obj.style; v=(v=='show')?'visible':(v='hide')?'hidden':v; }
    obj.visibility=v; }
}
function SV2_popupMsg(msg) { //v1.0
  alert(msg);
}
function SV2_openBrWindow(theURL,winName,features) { //v2.0
  window.open(theURL,winName,features);
}

function navto(where) {
	window.location = where+"?<?=SID?>";
}

SV2_showHideLayers('addCartMenu?header','','hide');
SV2_showHideLayers('blankLayer?header','','hide');
SV2_showHideLayers('linkLayer?header','','hide');
SV2_showHideLayers('newsletterLayer?header','','hide');
SV2_showHideLayers('cartMenu?header','','show');
SV2_showHideLayers('menuLayer?header','','hide');
SV2_showHideLayers('editCartMenu?header','','hide');

//-->
</script>

<SCRIPT LANGUAGE=JScript>

function preview_temp() {
		var data = "";

		if (document.TBUILD.TEMP_STYLE[0].checked) { var data = "TEMP_STYLE=BLANK&"; }
		if (document.TBUILD.TEMP_STYLE[1].checked) { var data = "TEMP_STYLE=LEFTBAR&"; }
		if (document.TBUILD.TEMP_STYLE[2].checked) { var data = "TEMP_STYLE=LSHAPE&"; }
		if (document.TBUILD.TEMP_STYLE[3].checked) { var data = "TEMP_STYLE=USHAPE&"; }
		if (document.TBUILD.TEMP_STYLE[4].checked) { var data = "TEMP_STYLE=PRO&"; }

		data = data + "FCOLOR="+document.TBUILD.FCOLOR_SEL.options(document.TBUILD.FCOLOR_SEL.selectedIndex).value+"&";
		data = data + "BCOLOR="+document.TBUILD.BCOLOR_SEL.options(document.TBUILD.BCOLOR_SEL.selectedIndex).value+"&";
		data = data + "TCOLOR="+document.TBUILD.TCOLOR_SEL.options(document.TBUILD.TCOLOR_SEL.selectedIndex).value+"&";
		data = data + "TXTCOLOR="+document.TBUILD.TXTCOLOR_SEL.options(document.TBUILD.TXTCOLOR_SEL.selectedIndex).value+"&";
		data = data + "LCOLOR="+document.TBUILD.LCOLOR_SEL.options(document.TBUILD.LCOLOR_SEL.selectedIndex).value+"&";
		data = data + "IMAGE="+document.TBUILD.IMAGE.options(document.TBUILD.IMAGE.selectedIndex).value+"&";
		
		eval("window.open('preview.php?"+data+"','temp_preview','width=750,height=450');");

}
	
</SCRIPT>

</head>

<body bgcolor=white text=black link=darkblue vlink=darkblue alink=darkblue leftmargin=0 topmargin=0 marginwidth=0 marginheight=0>
<DIV ID="userOpsLayer" style="position:absolute; visibility:visible; left:0px; top:0; width:100%; height:100%; z-index:1; overflow: auto; border: 1px none #000000">

<FORM NAME="TBUILD" METHOD="POST" ACTION="template_builder.php">

<?

####################################################################
### FOR VISUAL CONSISTANCY; WE USE AN HTML TEMPLATE BUILDER FILE 
### LOCATED IN THE /shared FOLDER.  THIS WAY ALL OF OUR MODULE 
### INTERFACES LOOK THE SAME. YOU MUST SUPPLY THE VARIABLES:
###
### $MOD_TITLE		Title of this Module
### $THIS_DISPLAY		HTML Content to display to end user
### $BG 			Background Image for content table if used
###
### THIS SAME METHOD SHOULD BE USED WHEN BUILDING ANY OF YOUR OWN 
### CUSTOM MODULES.  REMEMBER TO INCLUDE THE HEADER "INCLUDES"
### ABOVE FOR PROPER FUNCTIONALITY WITHIN THE APPLICAITON.
####################################################################

$THIS_DISPLAY = "";

ob_start(); 
	include("builder_form.html");
	$THIS_DISPLAY .= ob_get_contents(); 
ob_end_clean(); 

####################################################################

include("shared/html_build.php");
			
####################################################################

?>
 
</FORM>

</div>

<SCRIPT LANGUAGE=Javascript>

		document.TBUILD.FCOLOR_SEL.options.value = "000000";
		change_color("000000",'FCOLOR');
		
		document.TBUILD.BCOLOR_SEL.options.value = "F7F4C2";
		change_color("F7F4C2",'BCOLOR');
		
		document.TBUILD.TCOLOR_SEL.options.value = "FFFFFF";
		change_color("FFFFFF",'TCOLOR');
		
		document.TBUILD.TXTCOLOR_SEL.options.value = "000000";
		change_color("000000",'TXTCOLOR');
		
		document.TBUILD.LCOLOR_SEL.options.value = "4682B4";
		change_color("4682B4",'LCOLOR');
		
</SCRIPT>

</body>
<HEAD>
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE"></HEAD>
</html>