<?php

###############################################################################
## Soholaunch(R) Site Management Tool
## Version 4.5
##      
## Author: 			Mike Johnston [mike.johnston@soholaunch.com]                 
## Homepage:	 	http://www.soholaunch.com
## Bug Reports: 	http://bugzilla.soholaunch.com
## Release Notes:	sohoadmin/build.dat.php
###############################################################################

##############################################################################
## COPYRIGHT NOTICE                                                     
## Copyright 1999-2003 Soholaunch.com, Inc.  All Rights Reserved.       
##                                                                        
## This script may be used and modified in accordance to the license      
## agreement attached (license.txt) except where expressly noted within      
## commented areas of the code body. This copyright notice and the comments  
## comments above and below must remain intact at all times.  By using this 
## code you agree to indemnify Soholaunch.com, Inc, its coporate agents   
## and affiliates from any liability that might arise from its use.                                                        
##                                                                           
## Selling the code for this program without prior written consent is       
## expressly forbidden and in violation of Domestic and International 
## copyright laws.  		                                           
###############################################################################

session_start();
include("includes/db_connect.php");
error_reporting(0);

###########################################################################
##
## Decide on next step based on user input
##
###########################################################################

if ($submit == " << Back ") {

	header("Location: 2_pages.php?TEMPLATE=$TEMPLATE&PAGE_ARRAY=$PAGE_ARRAY&=SID");
	exit;

}

if (strlen($BIZ_NAME) < 2 || strlen($BIZ_EMAIL) < 5) {
	header("Location: 3_site_info.php?err=1&TEMPLATE=$TEMPLATE&PAGE_ARRAY=$PAGE_ARRAY&=SID");
	exit;

}

########################################################################
##
## Make sure our isp config file is stablized
##
########################################################################

if ($doc_root == "" || $cgi_bin == "") {
	echo ("ERROR: You have not conifgured the isp.conf file in the /conf directory to show an upload location");
	exit;
}

######################################################

$success = "";

function sterilize ($sterile_var) {
	$sterile_var = stripslashes($sterile_var);
	$st_l = strlen($sterile_var);
	$st_a = 0;
	$tmp = "";
	while($st_a != $st_l) {
		$temp = substr($sterile_var, $st_a, 1);
		if (eregi("[.0-9a-z_-]", $temp)) { $tmp .= $temp; }
		$st_a++;
	}
	$sterile_var = $tmp;
	return $sterile_var;
}

#######################################################
### STEP 1: CREATE REQ DIR STRUCTURES IF NOT EXIST  ###
#######################################################

$err = 0;

		$DIR = "$doc_root/media";
		if (!is_dir($DIR)) {
 			if (!mkdir ("$DIR", 0777)) { echo ("Dir Creation Error: Error Creating <B>$DIR</b> directory<BR>"); $err=1; };
		}

		$DIR = "$doc_root/images";
		if (!is_dir($DIR)) {
 			if (!mkdir ("$DIR", 0777)) { echo ("Dir Creation Error: Error Creating <B>$DIR</b> directory<BR>"); $err=1; };
		}

		$DIR = "$doc_root/import";
		if (!is_dir($DIR)) {
 			if (!mkdir ("$DIR", 0777)) { echo ("Dir Creation Error: Error Creating <B>$DIR</b> directory<BR>"); $err=1; };
		}

		$DIR = "$doc_root/tCustom";
		if (!is_dir($DIR)) {
 			if (!mkdir ("$DIR", 0777)) { echo ("Dir Creation Error: Error Creating <B>$DIR</b> directory<BR>"); $err=1; };
		}

if ($err == 1) { echo ("<h4><font color=red><U>Possible Solution:</U></font><BR><BR>Modify <U>isp.conf</U> file for doc_root to equal <U>$DOCUMENT_ROOT</U>.<BR>Remember, Linux is fickle!"); exit; }

#######################################################
### STEP 2: CONFIRM ACCEPTABLE FORMATS		    ###
#######################################################

for ($x=1;$x<=1;$x++) {
	$filename = "FILE".$x."_name";
	$filename = ${$filename};
	$filesize = "FILE".$x."_size";
	$filesize = ${$filesize};
	$FILE = "FILE".$x;
	$FILE = ${$FILE};

	// ---------------------------------------------------------------------------------------------------------------
	// DEVNOTE: IN CASE THIS SYSTEM IS RUNNING A PERL VERSION OF PHP; DO NOT ALLOW PHP CGI OR PHP.INI TO BE UPLOADED.
	//          THIS IS A MAJOR SECURITY FAULT.  DO NOT ERASE THE NEXT FEW LINES OF CODE OR A MALICIOUS
	//          SYSTEM USER COULD KILL YOUR SERVER
	//          AS LATER VERSIONS ARE RELEASED YOU MAY MODIFY THIS TO INCLUDE PHP5, PHP6, ETC.
	// ---------------------------------------------------------------------------------------------------------------

	if ($filename == "php4" || eregi("php.ini", $filename)) {
		echo ("Upload Error: Upload Security Violation in filename.");
		exit;
	}

	// ---------------------------------------------------------------------------------------------------------------
	// OK -- SECURITY CHECKED NOW MAKE SURE OF VALID FORMATS (THIS IS ANOTHER WAY TO SECURE YOUR SERVER)
	// ---------------------------------------------------------------------------------------------------------------

	$fileok = 0;
	$checkfor = strtolower($filename);
	$filename = eregi_replace(" ", "_", $filename);
	$filename = sterilize($filename);
	
	$UPLOADED_FILE = $filename;

	if (strstr($checkfor, ".gif")) {
		$newfile = "$doc_root/images/".$filename; 
		$fileok = 1;
	}

	if (strstr($checkfor, ".jpg")) {
		$newfile = "$doc_root/images/".$filename;
		$fileok = 1;
	}
	
	if (strstr($checkfor, ".bmp")) {
		$newfile = "$doc_root/images/".$filename; 
		$fileok = 1;
	}	
	
	if (strstr($checkfor, ".png")) {
		$newfile = "$doc_root/images/".$filename;
		$fileok = 1;
	}	

	if (strstr($checkfor, ".pdf")) {
		$newfile = "$doc_root/media/".$filename;
		$fileok = 1;
	}

	if (strstr($checkfor, ".rm")) {
		$newfile = "$doc_root/media/".$filename;
		$fileok = 1;
	}

	if (strstr($checkfor, ".wav")) {
		$newfile = "$doc_root/media/".$filename;
		$fileok = 1;
	}

	if (strstr($checkfor, ".ipx")) {
		$newfile = "$doc_root/media/".$filename;
		$fileok = 1;
	}

	if (strstr($checkfor, ".swf")) {
		$newfile = "$doc_root/media/".$filename;
		$fileok = 1;
	}

	if (strstr($checkfor, ".mp3")) {
		$newfile = "$doc_root/media/".$filename;
		$fileok = 1;
	}

	if (strstr($checkfor, ".avi")) {
		$newfile = "$doc_root/media/".$filename;
		$fileok = 1;
	}

	if (strstr($checkfor, ".exe")) {
		$newfile = "$doc_root/media/".$filename;
		$fileok = 1;
	}

	if (strstr($checkfor, ".mov")) {
		$newfile = "$doc_root/media/".$filename;
		$fileok = 1;
	}

	if (strstr($checkfor, ".xls")) {
		$newfile = "$doc_root/media/".$filename;
		$fileok = 1;
	}

	if (strstr($checkfor, ".doc")) {
		$newfile = "$doc_root/media/".$filename;
		$fileok = 1;
	}

	if (strstr($checkfor, ".css")) {
		$newfile = "$doc_root/".$filename;
		$fileok = 1;
	}

	if (strstr($checkfor, ".pl")) {
		$newfile = "$cgi_bin/".$filename;
		$fileok = 1;
	} 

	if (strstr($checkfor, ".php") || strstr($checkfor, ".inc")) {
		$newfile = "$doc_root/media/".$filename;
		$fileok = 1;
	} 

	if (strstr($checkfor, ".html") || strstr($checkfor, ".htm")) {
		$newfile = "$doc_root/media/".$filename;
		$fileok = 1;
	}

	if (strstr($checkfor, ".form")) {
		$newfile = "$doc_root/media/".$filename;
		$fileok = 1;
	}

	if (strstr($checkfor, ".txt")) {
		$newfile = "$doc_root/media/".$filename;
		$fileok = 1;
	}

	if (strstr($checkfor, ".exe") || strstr($checkfor, ".zip") || strstr($checkfor, ".tar") || strstr($checkfor, ".tgz") || strstr($checkfor, ".rpm")) {
		$newfile = "$doc_root/media/".$filename;
		$fileok = 1;
	}

	if (strstr($checkfor, ".csv")) {
		$newfile = "$doc_root/media/".$filename;
		$fileok = 1;
	}


	if(isset($FILE)) { 
	if($fileok == 1) {
		if (strlen($filename) > 0) { 

			$newfile = stripslashes($newfile);
			
			if (eregi("WIN", $WINDIR)) {
				$tempfile = $FILE;					// WIN32 UPLOAD
			} else {
				$tempfile = stripslashes($FILE); 	// LINUX UPLOAD
				@unlink($newfile); 
			} 

			if(@copy($tempfile, $newfile)) {
				 if ($filesize >= 1048576) { 
					$filesize = round($filesize/1048576*100)/100;
					$filesize = $filesize . "Mb";
				 } elseif ($filesize >= 1024) { 
					$filesize = round($filesize/1024*100)/100;
					$filesize = $filesize . "K"; 
				 } else {
					$filesize = $filesize . "Bytes";
				 }	

				if (strstr($checkfor, ".pl")) {
					chmod ("$newfile", 0775); 
				}

				$success .= "||<U>$filename</U>~~~(".$filesize.")~~~Success!";
 			} else { 
				$success .= "||<U>$filename</U> Did NOT Upload!~~~N/A ~~~<font color=red>System Error!</font>";
			} 
		}
	} else {
		if (strlen($filename)>0) {
			$success .= "||<U>$filename</U> Did NOT Upload!~~~N/A~~~<font color=red>File is not an accepted file format.</font>";
		}
	}
	}

	if (strstr($filename, ".pl") || strstr($filename, ".txt") || strstr($filename, ".inc") || strstr($filename, ".php") || strstr($filename, ".form")) {
			while (!file_exists("$newfile")) {
				# Wait
			}	
			$nfilename = "$newfile";
			$nfile = fopen("$nfilename", "r");
				$nbody = fread($nfile,filesize($nfilename));
			fclose($nfile);
			$nbody = eregi_replace("\n", "", $nbody);
			$nlines = split("\r", $nbody);
			$nnumLines = count($nlines);

			$nfile = fopen("$nfilename", "w");
			for ($z=0;$z<=$nnumLines;$z++) {
				fwrite($nfile, "$nlines[$z]\n");
			}
			fclose($nfile);
			@chmod ("$newfile", 0775); 
	}

	
}


###################################################################
### PARSE AND CLEAN PASSED DATA VARIABLES 			   			###
###################################################################

	reset($HTTP_POST_VARS);
	while (list($name, $value) = each($HTTP_POST_VARS)) {
		$value = stripslashes($value);			// Strip all slashes from data for HTML execution
		${$name} = $value;
		// echo "$name: $value;<BR>";
	}
	
	$BIZ_EMAIL = ltrim($BIZ_EMAIL);
	$BIZ_EMAIL = rtrim($BIZ_EMAIL);

	$BIZ_NAME = stripslashes($BIZ_NAME);
	$BIZ_NAME = ltrim($BIZ_NAME);
	$BIZ_NAME = rtrim($BIZ_NAME);
	
	// In case no image is uploaded during wizard process
	
	if (strlen($UPLOADED_FILE) < 2) {
		$UPLOADED_FILE = "image_global.gif";
	}
	

###################################################################
#### STEP 3: Read and Copy Content Now				   ####
###################################################################

	$tmp = split(";", $PAGE_ARRAY);
	$tmp_cnt = count($tmp);

	for ($x=0;$x<=$tmp_cnt;$x++) {

		if (strlen($tmp[$x]) > 2) {

			$tmp[$x] = rtrim($tmp[$x]);
			$tmp[$x] = ltrim($tmp[$x]);

				// ===========================================================

				$CONTENT = "";

				$from_file = eregi_replace(" ", "_", $tmp[$x]);
				$from_file = "content/$from_file.con";
				
				
				$to_file = eregi_replace(" ", "_", $tmp[$x]);
				$to_file = "$cgi_bin/$to_file.con";
				
				if (eregi("IIS", $SERVER_SOFTWARE)) {	// Correct File Path For Win IIS Systems
					$from_file = eregi_replace("/", "\\", $from_file);
					$to_file = eregi_replace("/", "\\", $to_file);
				}
					
				$file = fopen("$from_file", "r");
					$CONTENT = fread($file,filesize($from_file));
				fclose($file);

				$CONTENT = eregi_replace("#COMPANY#", $BIZ_NAME, $CONTENT);
				$CONTENT = eregi_replace("#EMAIL#", $BIZ_EMAIL, $CONTENT);
				$CONTENT = eregi_replace("#DBNAME#", "Contact_Form", $CONTENT);

				$CONTENT = eregi_replace("SOHOLAUNCH-LOGO.jpg", $UPLOADED_FILE, $CONTENT);
				$CONTENT = eregi_replace("216.169.154.93", $this_ip, $CONTENT);
				
					$CONTENT = eregi_replace("webmaster@mikejsolutions.com", "webmaster@$this_ip", $CONTENT);
					$CONTENT = eregi_replace("mikejsolutions.com auto-response", "$this_ip auto-response", $CONTENT);
					$CONTENT = eregi_replace("/usr/share/web/mikej/webshare/", "$doc_root/", $CONTENT);

				$CONTENT = eregi_replace("width=597 height=163", "", $CONTENT);


				$filename = "$to_file";
				
				$file = fopen("$filename", "w");
					fwrite($file, "$CONTENT");
				fclose($file);

				// ===========================================================

				// ===========================================================

				$CONTENT = "";

				$from_file = eregi_replace(" ", "_", $tmp[$x]);
				$from_file = "content/$from_file.regen";

				$to_file = eregi_replace(" ", "_", $tmp[$x]);
				$to_file = "$cgi_bin/$to_file.regen";
				
				if (eregi("IIS", $SERVER_SOFTWARE)) {	// Correct File Path For Win IIS Systems
					$from_file = eregi_replace("/", "\\", $from_file);
					$to_file = eregi_replace("/", "\\", $to_file);
				}
					
				$file = fopen("$from_file", "r");
					$CONTENT = fread($file,filesize($from_file));
				fclose($file);

				$CONTENT = eregi_replace("#COMPANY#", $BIZ_NAME, $CONTENT);
				$CONTENT = eregi_replace("#EMAIL#", $BIZ_EMAIL, $CONTENT);
				$CONTENT = eregi_replace("#DBNAME#", "Contact_Form", $CONTENT);

				$CONTENT = eregi_replace("SOHOLAUNCH-LOGO.jpg", $UPLOADED_FILE, $CONTENT);
				$CONTENT = eregi_replace("216.169.154.93", $this_ip, $CONTENT);

					$CONTENT = eregi_replace("webmaster@mikejsolutions.com", "webmaster@$this_ip", $CONTENT);
					$CONTENT = eregi_replace("mikejsolutions.com auto-response", "$this_ip auto-response", $CONTENT);
					$CONTENT = eregi_replace("/usr/share/web/mikej/webshare/", "$doc_root/", $CONTENT);
				
				$CONTENT = eregi_replace("width=597 height=163", "", $CONTENT);

				
				$filename = "$to_file";
				$file = fopen("$filename", "w");
					fwrite($file, "$CONTENT");
				fclose($file);

				// ===========================================================


		} // End If

	}

###################################################################
#### STEP 4: Configure Auto-Menu Table Now (include Home Page) ####
###################################################################

	// ------------------------------------------------------
	// FIRST, DELETE ALL MENU NUMBER REFERENCES AND      
	// SUB PAGE REFERENCES FROM site_pages TABLE         	
	// ------------------------------------------------------

	$result = mysql_query("SELECT page_name FROM site_pages WHERE type = 'Main'");

	while ($row = mysql_fetch_array ($result)) {
		mysql_query("UPDATE site_pages SET main_menu = '' WHERE page_name = '$row[page_name]'"); 
		mysql_query("UPDATE site_pages SET sub_page_of = '' WHERE page_name = '$row[page_name]'"); 
	}

 
	$tmp = split(";", $PAGE_ARRAY);
	$tmp_cnt = count($tmp);

	sort($tmp);

	$y = 0;

	for ($x=0;$x<=$tmp_cnt;$x++) {

		if (strlen($tmp[$x]) > 2) {

			$tmp[$x] = rtrim($tmp[$x]);
			$tmp[$x] = ltrim($tmp[$x]);
			$link = md5($tmp[$x]);
			$link = substr($link, 1, 10);

			$y++;
			$SQL_INSERT = "VALUES('$tmp[$x]','Main','', '', '$y','$link','','')";
			mysql_query("INSERT INTO site_pages $SQL_INSERT");
			$err_check = mysql_errno();
			if ($err_check == "1062") {
				mysql_query("UPDATE site_pages SET main_menu = '$y' WHERE page_name = '$tmp[$x]'");
			}


		} // End If

	}

###################################################################
#### STEP 5: Create Needed System Tables (Populate Defaults)   ####
###################################################################

	// ----------------------------------------------------
	// IF THE 'calendar_display' TABLE DOES NOT EXIST; 
	// CREATE NOW 
	// ----------------------------------------------------

		$match = 0;		
		$tablename = "calendar_display";

		$result = mysql_list_tables("$db_name");
		$i = 0; 
		while ($i < mysql_num_rows ($result)) { 
			$tb_names[$i] = mysql_tablename ($result, $i); 
			if ($tb_names[$i] == $tablename) {
				$match = 1;
			}
			$i++;
		} 

		if ($match != 1) {
			
			mysql_db_query("$db_name","CREATE TABLE calendar_display (

				PRIKEY INT NOT NULL AUTO_INCREMENT PRIMARY KEY, 				
				TEXT_COLOR CHAR(7),
				BACKGROUND_COLOR CHAR(7),
				ALLOW_PERSONAL_CALENDARS CHAR(1),
				DISPLAY_STYLE CHAR(1),
				ALLOW_PUBLIC_SUBMISSIONS CHAR(1),
				EMAIL_CONFIRMATION CHAR(255),
				FUTURE1 BLOB,
				FUTURE2 BLOB)");

				$SQL_INSERT = "VALUES('NULL','','','','','','','','')";
				mysql_query("INSERT INTO calendar_display $SQL_INSERT");

				
		} // End if Match != 1

	// ----------------------------------------------------
	// Populate Calendar Defaults
	// ----------------------------------------------------

	mysql_query("UPDATE calendar_display SET TEXT_COLOR = 'FFFFFF', BACKGROUND_COLOR = '708090',
		ALLOW_PERSONAL_CALENDARS = 'Y', DISPLAY_STYLE = 'M', ALLOW_PUBLIC_SUBMISSIONS = 'Y',
		EMAIL_CONFIRMATION = '$BIZ_EMAIL' WHERE PRIKEY = '1'");




###################################################################
#### STEP 6: Copy and Configure Template Selection             ####
###################################################################

	// ----------------------------------------------------
	// Delete Old Template Files				   
	// ----------------------------------------------------	

	$template_dir = "$doc_root/template";
	$directory = $template_dir;

	
	if (is_dir($directory)) {
		$handle = opendir("$directory");
		while ($files = readdir($handle)) {
			if (strlen($files) > 2) {
				$deleteit = $directory."/".$files;
				@unlink($deleteit);
			}
		}
		closedir($handle);
	}

	$directory = "../modules/site_templates/pages/$TEMPLATE";

	$handle = opendir("$directory");
	while ($files = readdir($handle)) {

		if (strlen($files) > 2) {	

			$basefile = "$directory/".$files;		
			$clientfile = $template_dir."/".$files;

			@copy($basefile, $clientfile);
		}
	}
	closedir($handle);

	// Now right template.conf file so that we can load the current 
	// template from memory next time user enters "Site Templates" option

	$filename = $template_dir . "/template.conf";
	$file = fopen("$filename", "w");
		fwrite($file, "site_templates/pages/$TEMPLATE/screenshot.gif\n");
	fclose($file);


###################################################################
#### STEP 7: Write company name to Template Header Section     ####
###################################################################

	// Template Header

	$filename = "$cgi_bin/logo.conf";
 	$file = fopen("$filename", "w");
 	fwrite($file, "headertext=$BIZ_NAME\n");
 	fwrite($file, "subheadertext=\n");
 	fclose($file);

	// Site Title

	$filename = "$cgi_bin/meta.conf";

	$file = fopen("$filename", "w");
	fwrite($file, "site_description=$BIZ_NAME\n");
	fwrite($file, "site_keywords=\n");
	fwrite($file, "site_title=$BIZ_NAME Website\n");
	fwrite($file, "splash_bg=FFFFFF\n");
	fclose($file);

	// Menu Conf

	$filename = "$cgi_bin/menu.conf";

	$file = fopen("$filename", "w");
		fwrite($file, "mainmenu=vertical\n");
		fwrite($file, "submenu=veritical\n");
	 	fwrite($file, "locationbar=\n");
	 	fwrite($file, "textmenu=on\n");
		fwrite($file, "MENUTYPE=buttons\n");
	fclose($file);

###################################################################
#### DONE
###################################################################

sleep(2);
header("Location: 5_complete.php?=SID");

?>