<?php
class XoopsDatabaseFactory
{

	function XoopsDatabaseFactory()
	{
	}

	/**
	 * get a reference to the only instance of database class
     * 
     * if the class has not been instantiated yet, this will also take 
     * care of that
	 * 
     * @static
     * @staticvar   object  The only instance of database class
     * @return      object  Reference to the only instance of this class
	 */
	function &get()
	{
		static $instance;
		if (!isset($instance)) {
			switch(XOOPS_DB_TYPE) {
			case 'mysql':
				require_once XOOPS_ROOT_PATH.'/class/database/mysql/db.php';
				$instance = !defined('XOOPS_DB_PROXY') ? new XoopsMySQLDatabaseSafe() : new XoopsMySQLDatabaseProxy();
				break;
			default:
				break;
			}
			$instance->setLogger(XoopsLogger::instance());
			$instance->setPrefix(XOOPS_DB_PREFIX);
			if (!$instance->connect()) {
				return false;
			}
		}
		return $instance;
	}

}
?>