<?php
// $Id: search.php,v 1.9 2003/06/13 04:48:05 okazu Exp $
//  ------------------------------------------------------------------------ //
//                XOOPS - PHP Content Management System                      //
//                    Copyright (c) 2000 XOOPS.org                           //
//                       <http://www.xoops.org/>                             //
//  ------------------------------------------------------------------------ //
//  This program is free software; you can redistribute it and/or modify     //
//  it under the terms of the GNU General Public License as published by     //
//  the Free Software Foundation; either version 2 of the License, or        //
//  (at your option) any later version.                                      //
//                                                                           //
//  You may not change or alter any portion of this comment or credits       //
//  of supporting developers from this source code or any supporting         //
//  source code which is considered copyrighted (c) material of the          //
//  original comment or credit authors.                                      //
//                                                                           //
//  This program is distributed in the hope that it will be useful,          //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of           //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//  GNU General Public License for more details.                             //
//                                                                           //
//  You should have received a copy of the GNU General Public License        //
//  along with this program; if not, write to the Free Software              //
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA //
//  ------------------------------------------------------------------------ //

$xoopsOption['pagetype'] = "search";

include 'mainfile.php';
$config_handler =& xoops_gethandler('config');
$xoopsConfigSearch =& $config_handler->getConfigsByCat(XOOPS_CONF_SEARCH);

if ($xoopsConfigSearch['enable_search'] != 1) {
	header('Location: '.XOOPS_URL.'/index.php');
	exit();
}

include_once XOOPS_ROOT_PATH."/class/xoopsformloader.php";

$action = isset($HTTP_POST_VARS['action']) ? trim($HTTP_POST_VARS['action']) : "search";
$query = isset($HTTP_POST_VARS['query']) ? trim($HTTP_POST_VARS['query']) : "";
$andor = isset($HTTP_POST_VARS['andor']) ? trim($HTTP_POST_VARS['andor']) : "AND";
$mids = isset($HTTP_POST_VARS['mids']) ? $HTTP_POST_VARS['mids'] : array();
$mid = isset($HTTP_POST_VARS['mid']) ? intval($HTTP_POST_VARS['mid']) : 0;
$uid = isset($HTTP_POST_VARS['uid']) ? intval($HTTP_POST_VARS['uid']) : 0;
$start = isset($HTTP_POST_VARS['start']) ? intval($HTTP_POST_VARS['start']) : 0;

if ( $action == "results" && $query == "" ) {
	redirect_header("search.php",1,_SR_PLZENTER);
	exit();
}

if ( $action == "showall" && ($query == "" || empty($mid)) ) {
	redirect_header("search.php",1,_SR_PLZENTER);
	exit();
}

if ($action == "showallbyuser" && (empty($mid) || empty($uid))) {
	redirect_header("search.php",1,_SR_PLZENTER);
	exit();
}

if ( $andor != "OR" && $andor != "exact" && $andor != "AND" ) {
	$andor = "AND";
}

if ( $action == "results" ) {
	$myts =& MyTextSanitizer::getInstance();
	if ( !is_array($mids) || count($mids) == 0 ) {
		unset($mids);
		$module_handler =& xoops_gethandler('module');
		$criteria = new CriteriaCompo(new Criteria('hassearch', 1));
		$criteria->add(new Criteria('isactive', 1));
		$mids =& array_keys($module_handler->getList($criteria));
	}
	if ( $andor != "exact" ) {
		$temp_queries = preg_split('/[\s,]+/', $query);
		$queries = array();
		foreach ($temp_queries as $q) {
			if (strlen(trim($q)) >= $xoopsConfigSearch['keyword_min']) {
				$queries[] = $myts->addSlashes($q);
			}
		}
		if (count($queries) == 0) {
			redirect_header('search.php', 2, sprintf(_SR_KEYTOOSHORT, $xoopsConfigSearch['keyword_min']));
			exit();
		}
	} else {
		if (strlen(trim($query)) < $xoopsConfigSearch['keyword_min']) {
			redirect_header('search.php', 2, sprintf(_SR_KEYTOOSHORT, $xoopsConfigSearch['keyword_min']));
			exit();
		}
		$queries = array($myts->addSlashes($query));
	}
	include XOOPS_ROOT_PATH."/header.php";
	echo "<h3>"._SR_SEARCHRESULTS."</h3>\n";
	echo _SR_KEYWORDS.':';
	if ($andor != 'exact') {
		foreach ($queries as $q) {
			echo ' <b>'.htmlspecialchars(stripslashes($q)).'</b>';
		}
	} else {
		echo ' "<b>'.htmlspecialchars(stripslashes($queries[0])).'</b>"';
	}
	echo '<br />';
	$module_handler =& xoops_gethandler('module');
	foreach ($mids as $mid) {
		$mid = intval($mid);
		$module =& $module_handler->get($mid);
		$results =& $module->search($queries, $andor, 5, 0);
		echo "<h4>".$module->getVar('name')."</h4>";
		$count = count($results);
		if (!is_array($results) || $count == 0) {
			echo "<p>"._SR_NOMATCH."</p>";
		} else {
			for ($i = 0; $i < $count; $i++) {
				if (isset($results[$i]['image']) && $results[$i]['image'] != "") {
					echo "<img src='modules/".$module->getVar('dirname')."/".$results[$i]['image']."' alt='".$module->getVar('name')."' />&nbsp;";
				} else {
					echo "<img src='images/icons/posticon2.gif' alt='".$module->getVar('name')."' width='26' height='26' />&nbsp;";
				}
				echo "<b><a href='modules/".$module->getVar('dirname')."/".$results[$i]['link']."'>".$myts->makeTboxData4Show($results[$i]['title'])."</a></b><br />\n";
				echo "<small>";
				$results[$i]['uid'] = intval($results[$i]['uid']);
				if ( !empty($results[$i]['uid']) ) {
					$uname = XoopsUser::getUnameFromId($results[$i]['uid']);
					echo "&nbsp;&nbsp;<a href='".XOOPS_URL."/userinfo.php?uid=".$results[$i]['uid']."'>".$uname."</a>\n";
				}
				echo $results[$i]['time'] ? " (". formatTimestamp(intval($results[$i]['time'])).")" : "";
				echo "</small><br />\n";
			}
			if ( $count == 5 ) {
				echo "<br /><form action='search.php' method='post' id='xoopssearch".$mid."' name='xoopssearch".$mid."'>
				<input type='hidden' value='".$myts->makeTboxData4PreviewInForm($query)."' name='query' />
				<input type='hidden' name='mid' value='".$mid."' />
				<input type='hidden' name='action' value='showall' />
				<input type='hidden' name='andor' value='".$andor."' />
				<a href='#$mid' onclick=\"xoopsGetElementById('xoopssearch".$mid."').submit();\">"._SR_SHOWALLR."</a></form></p>";
			}
		}
		unset($results);
		unset($module);
	}
	//CloseTable();
}

if ( $action =="search" || $action =="results" ) {
	if ( $action == "search" ) {
		include XOOPS_ROOT_PATH."/header.php";
	}
	//OpenTable();
	include "include/searchform.php";
	$search_form->display();
	//CloseTable();
}

if ($action == "showall" || $action=='showallbyuser') {
	$myts =& MyTextSanitizer::getInstance();
	if ($action == 'showall') {
		if ( $andor != "exact" ){
			$queries = split(" ",$myts->oopsAddSlashes($query));
		} else {
			$queries = array($myts->oopsAddSlashes($query));
		}
		foreach ($queries as $q) {
			$q = trim($q);
			if (strlen(trim($q)) < $xoopsConfigSearch['keyword_min']) {
				redirect_header('search.php', 2, sprintf(_SR_KEYTOOSHORT, $xoopsConfigSearch['keyword_min']));
				exit();
			}
		}
	}
	include XOOPS_ROOT_PATH."/header.php";
	$module_handler =& xoops_gethandler('module');
	$module =& $module_handler->get($mid);
	$results =& $module->search($queries, $andor, 20, $start, $uid);
	$count = count($results);
	if (!is_array($results) || $count == 0) {
			echo '<p>'._SR_NOMATCH.'</p>';
	}
	$next_results =& $module->search($queries, $andor, 1, $start + 20, $uid);
	$next_count = count($next_results);
	$has_next = false;
	if (is_array($next_results) && $next_count == 1) {
			$has_next = true;
	}
	//OpenTable();
	echo "<h4>"._SR_SEARCHRESULTS."</h4>\n";
//	printf(_SR_FOUND,$count);
//	echo "<br />";
	printf(_SR_SHOWING, $start+1, $start + $count);
	echo "<h5>".$module->getVar('name')."</h5>";
	for ($i = 0; $i < $count; $i++) {
		if (isset($results[$i]['image']) && $results[$i]['image'] != '') {
			echo "<img src='modules/".$module->getVar('dirname')."/".$results[$i]['image']."' alt='".$module->getVar('name')."' />&nbsp;";
		} else {
			echo "<img src='images/icons/posticon2.gif' alt='".$module->name()."' width='26' height='26' />&nbsp;";
		}
		echo "<b><a href='modules/".$module->getVar('dirname')."/".$results[$i]['link']."'>".$myts->makeTboxData4Show($results[$i]['title'])."</a></b><br />\n";
		echo "<small>";
		$results[$i]['uid'] = intval($results[$i]['uid']);
		if ( !empty($results[$i]['uid']) ) {
			$uname = XoopsUser::getUnameFromId($results[$i]['uid']);
			echo "&nbsp;&nbsp;<a href='".XOOPS_URL."/userinfo.php?uid=".$results[$i]['uid']."'>".$uname."</a>\n";
		}
		echo $results[$i]['time'] ? " (". formatTimestamp(intval($results[$i]['time'])).")" : "";
		echo "</small><br />\n";
	}
	echo "<table><tr>";
	if ( $start > 0 ) {
		$prev = $start - 20;
		echo "<td align='left'><form action='search.php' method='post' id='xoopssearch_prev' name='xoopssearch_prev'>
		<input type='hidden' value='".$myts->makeTboxData4PreviewInForm($query)."' name='query' />
		<input type='hidden' name='mid' value='".$mid."' />
		<input type='hidden' name='action' value='".$action."' />
		<input type='hidden' name='andor' value='".$andor."' />
		<input type='hidden' name='start' value='".$prev."' />";
		if ($action=='showallbyuser') {
			echo '<input type="hidden" value="'.$uid.'" name="uid" />';
		}
		echo "<a href='#$prev' onclick=\"xoopsGetElementById('xoopssearch_prev').submit();\">"._SR_PREVIOUS."</a></form></td>\n";
	}
	echo "<td>&nbsp;&nbsp;</td>";
	if (false != $has_next) {
		$next = $start + 20;
		echo "<td align='right'><form action='search.php' method='post' id='xoopssearch_next' name='xoopssearch'>
		<input type='hidden' value='".$myts->makeTboxData4PreviewInForm($query)."' name='query' />
		<input type='hidden' name='mid' value='".$mid."' />
		<input type='hidden' name='action' value='".$action."' />
		<input type='hidden' name='andor' value='".$andor."' />
		<input type='hidden' name='start' value='".$next."' />";
		if ($action=='showallbyuser') {
			echo '<input type="hidden" value="'.$uid.'" name="uid" />';
		}
		echo "<a href='#$next' onclick=\"xoopsGetElementById('xoopssearch_next').submit();\">"._SR_NEXT."</a></form></td>\n";
	}
	echo "</tr></table><p>\n";
	include "include/searchform.php";
	$search_form->display();
	echo "</p>";
	//CloseTable();
}

include XOOPS_ROOT_PATH."/footer.php";

?>
